#include <stdio.h>
#include <stdlib.h>

#define TRUE 1
#define FALSE 0
#define NILL -1
#define INF -1

int jeManji(float i, float j)
{
	if(i==INF)
		return FALSE;
	else if(j==INF)
		return TRUE;
	return (i<j);
}

int nadjiMin(float *d, int *obidjen, int *obidjenJov, int n)
{
	float min=INF;
	int minCvor=NILL,i;
	
	for(i=0; i<n; i++)
	{
		if(obidjen[i]==FALSE && obidjenJov[i]==FALSE && jeManji(d[i],min))
		{
			min=d[i];
			minCvor=i;
		}
	}
	return minCvor;

}


void relax(float **graf, float *d, int *pret, int u, int v)
{
	if(jeManji(graf[u][v]+d[u],d[v]))
	{
		d[v]=graf[u][v]+d[u];
		pret[v]=u;
	}
}

void dijkstra(float **graf, float *d, int *pret, int *obidjen, int *obidjenJov, int n)
{
	int v,u;
	while((u=nadjiMin(d,obidjen,obidjenJov,n))!=NILL)
	{
		obidjen[u]=TRUE;
		
		for(v=0;v<n;v++)
		{
			if(graf[u][v]!=INF && obidjen[v]==FALSE && obidjenJov[v]==FALSE)
				relax(graf,d,pret,u,v);
		}
	}
}

int rekonstrukcija(int *pret, int polaz, int v, int *niz)
{
	int br=0;
	while(v!=NILL)
	{
		niz[br++]=v;
		v=pret[v];
	}
	return br;
}

float odrediKilometrazu(int *niz, int n, float **kilometraza)
{
	float kil=0;
	int i;
	for(i=0;i<n-1;i++)
	{
		kil += kilometraza[niz[i]][niz[i+1]];
	}
	return kil;
}

int main()
{
	float **graf, *d;
	int *pret, *obidjen, *obidjenJov;
	float cenaGoriva, potrosnjaReg, potrosnjaAuto;
	int n,m,i,j,u,v,autoput,l;
	float putarina, tezina, **kilometraza;
	
	scanf("%f%f%f",&cenaGoriva,&potrosnjaAuto,&potrosnjaReg);
	scanf("%d%d",&n,&m);
	graf=(float**)malloc(sizeof(float*)*n);
	d=(float*)malloc(sizeof(float)*n);
	kilometraza=(float**)malloc(sizeof(float*)*n);
	pret=(int*)malloc(sizeof(int)*n);
	obidjen=(int*)malloc(sizeof(int)*n);
	obidjenJov=(int*)malloc(sizeof(int)*n);
	
	for(i=0;i<n;i++)
	{
		graf[i]=(float*)malloc(sizeof(float)*n);
		kilometraza[i]=(float*)malloc(sizeof(float)*n);
	}
		
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			graf[i][j]=INF;
			kilometraza[i][j]=INF;
		}
		obidjen[i]=FALSE;
		obidjenJov[i]=FALSE;
		d[i]=INF;
		pret[i]=NILL;
	}
	
	//printf("Dosaoo");
	
	for(i=0;i<m;i++)
	{
		scanf("%d%d%d%d",&u,&v,&l,&autoput);
		if(autoput==1)
		{
			scanf("%f",&putarina);
			tezina=((potrosnjaAuto*l)/100)*cenaGoriva+putarina;
		}
		else
		{
			tezina=((potrosnjaReg*l)/100)*cenaGoriva;
		}
		//printf("Ubacio");
		if(jeManji(tezina,graf[u][v]))
		{
				graf[u][v]=tezina;
				graf[v][u]=tezina;
				kilometraza[u][v]=l;
				kilometraza[v][u]=l;
		}
		
		
		
	}
	
	int polaz, odrediste, indikator=0;
	scanf("%d%d",&polaz,&odrediste);
	
	d[polaz]=0;
	//printf("USAOO");
	dijkstra(graf,d,pret,obidjen,obidjenJov,n);
	
	int br, *niz, *niz1;
	niz=(int*)malloc(sizeof(int)*n);
	niz1=(int*)malloc(sizeof(int)*n);
	
	br=rekonstrukcija(pret,polaz,odrediste,niz);
	//printf("%f\n",d[odrediste]*cenaGoriva);
	float ukupnaCena=d[odrediste];
	float ukupno=odrediKilometrazu(niz,br,kilometraza);
	//printf("%f\n",ukupno);
	if(niz[br-1]==polaz)
	{
		/*
		for(i=br-1;i>=0; i--)
		{
			printf("%d ",niz[i]);
			if(i!=br-1 && i!= 0)
				obidjenJov[niz[i]]=TRUE;
		}
		* */
	}
	else
	{
		indikator=-1;
	}
	if(indikator!=-1)
	{
		int br1;
	for(i=br-1;i>0;i--)
	{
		if(i!=br-1 && i!= 0)
					obidjenJov[niz[i]]=TRUE;
	}
		
		for(i=0;i<n;i++)
		{
			d[i]=INF;
			obidjen[i]=FALSE;
			pret[i]=NILL;
		}
		d[polaz]=0;
		dijkstra(graf,d,pret,obidjen,obidjenJov,n);
		br1=rekonstrukcija(pret,polaz,odrediste,niz1);
		ukupnaCena += d[odrediste];
		ukupnaCena = ukupnaCena;
		if(niz1[br1-1]==polaz) printf("%f\n",ukupnaCena);
		ukupno += odrediKilometrazu(niz1,br1,kilometraza);
		if(niz1[br1-1]==polaz) printf("%f\n",ukupno);
		if(d[odrediste]!=INF || niz1[br1-1]==polaz)
		{
			for(i=br-1;i>=0; i--)
			{
				printf("%d ",niz[i]);
				
			}
			for(i=1; i<br1; i++)
			{
				printf("%d ",niz1[i]);
				
			}
		}
		else
		{
			printf("-1");
		}
	}
	else
	{
		printf("-1");
	}
	
	return 0;
}




















