#include <stdio.h>
#include <stdlib.h>

#define INF -1
#define NILL -1
#define TRUE 1
#define FALSE 0

int jeManji(int a, int b)
{
	if(a==INF)
		return FALSE;
	if(b==INF)
		return TRUE;
	return (a<b);
}

int nadjiMin(float *rast, int *obidjen, int n)
{
	int i;
	int min = INF, minCvor = NILL;
	for(i = 0; i < n; i++)
	{
		if(obidjen[i]==FALSE && jeManji(rast[i],min))
		{
			min = rast[i];
			minCvor = i;
		}
	}
	return minCvor;
}

void relax(float **graf, float *rast, int *pret, int u, int v, int n /*,float **grafCena*/)
{
	if(jeManji(rast[u]+graf[u][v], rast[v]))
	{
		rast[v] = rast[u]+graf[u][v];
		pret[v] = u;
	}
}

void dijkstra(float **graf, float *rast, int *pret, int *obidjen, int n /*,float **grafCena*/)
{
	int u,i,v;
	for(i = 0; i < n; i++)
	{
		u = nadjiMin(rast, obidjen, n);
		if(u==-1)
			break;
		obidjen[u] = TRUE;
		for(v = 0; v < n; v++)
		{
			if(obidjen[v]==FALSE && graf[u][v]!=INF)
				relax(graf, rast, pret, u, v, n);
		}
	}
}


int rekonstrukcija(int i, int *pret, int polaziste, int *put, int *br)
{	
	if(pret[i] == -1)
	{
		if(i==polaziste)
			return 0;
		else
			return -1;
	}
	else
	{
		
		rekonstrukcija(pret[i], pret, polaziste, put, br);
		put[*br] = pret[i];
		(*br)++;
	}
	return 0;
}

int main()
{
	float cenaGoriva;
	scanf("%f", &cenaGoriva);
	
	float potGorivaAuto, potGorivaReg;
	scanf("%f %f", &potGorivaAuto, &potGorivaReg);
	
	int n, m;
	scanf("%d %d", &n, &m);
	
	float **graf;
	//float **graf cena;
	float *rast;
	int *obidjen, *pret;
	int u, v, l, autoput,putarina;
	int i,j;
	
	graf=(float**)malloc(n*sizeof(float*));
	//grafCena=(float**)malloc(n*sizeof(float*));
	rast=(float*)malloc(n*sizeof(float));
	pret=(int*)malloc(n*sizeof(int));
	obidjen=(int*)malloc(n*sizeof(int));
	
	for(i = 0; i < n; i++)
	{
		graf[i]=(float*)malloc(n*sizeof(float));
		//grafCena=(float*)malloc(n*sizeof(float));
	}
	
	for(i = 0; i < n; i++)
	{
		rast[i] = INF;
		pret[i] = NILL;
		obidjen[i] = FALSE;
		for(j = 0; j < n; j++)
			graf[i][j] = INF;
	}
	
	for(i = 0; i < m; i++)
	{
		scanf("%d %d %d %d", &u, &v, &l, &autoput);
		//da se izmeni
		//if(graf[u][v]!=INF && grafCena...)
		if(autoput==1)
			scanf("%d", &putarina);
		graf[u][v] = graf[v][u] = l;
	}
	
	int polaziste, odrediste;
	scanf("%d %d", &polaziste, &odrediste);
	
	rast[polaziste] = 0;
	
	dijkstra(graf, rast, pret, obidjen, n);	
	
	/*
	for(i = 0; i < n; i++, printf("\n"))
		for(j = 0; j < n; j++)
			printf("%d ", graf[i][j]);

	for(i = 0; i < n; i++)
		printf("%d ", rast[i]);
	printf("\n");
	for(i = 0; i < n; i++)
		printf("%d ", pret[i]);
	printf("\n");
	*/
	
	int br = 0;
	int put[n];
	
	if(rekonstrukcija(odrediste, pret, polaziste, put, &br))
		printf("-1");
	else
	{
		for(i = 1; i < br; i++)
		{
			for(u = 0; u < n; u++)
			{
				for(v = 0; v < n; v++)
				{
					if(put[i] == u || put[i] == v)
						graf[u][v] = graf[v][u] = INF;
				}
			}
		}
		
		/*
		printf("Osvezen graf\n");
		for(i = 0; i < n; i++, printf("\n"))
			for(j = 0; j < n; j++)
				printf("%d ", graf[i][j]);
		*/
		
		int *pretO, *obidjenO;
		float *rastO;
		rastO=(float*)malloc(n*sizeof(float));
		pretO=(int*)malloc(n*sizeof(int));
		obidjenO=(int*)malloc(n*sizeof(int));
		
		for(i = 0; i < n; i++)
		{
			rastO[i] = INF;
			pretO[i] = NILL;
			obidjenO[i] = FALSE;
		}
		
		rastO[odrediste] = 0;
		dijkstra(graf, rastO, pretO, obidjenO, n);
		/*
		for(i = 0; i < n; i++)
			printf("%d ", rastO[i]);
		printf("\n");
		for(i = 0; i < n; i++)
			printf("%d ", pretO[i]);
		printf("\n");
		*/
		
		if((rekonstrukcija(polaziste, pretO, odrediste, put, &br)==-1))
			printf("-1");
		else{
			printf("%.4f\n", rast[odrediste]+rastO[polaziste]);
			for(i = 0; i < br; i++)
			{
				printf("%d ", put[i]);
			}
			printf("%d", polaziste);
			printf("\n");
		}
	}	
	return 0;
}
