#include<stdio.h>
#include<stdlib.h>

#define SKUP_N 0
#define SKUP_B 1

int nadjiUlaz(int *BN, double *c, int n, int m){
	int i;
	int e = -1;
	for(i=0;i<(n+m);i++){
		if(BN[i] == SKUP_N && c[i]>0){
			e = i;
			break;
		}
	}
	return e;
}

int nadjiIzlaz(int e, int *BN, double **a, double *b, int n, int m){
	int i;
	double min;
	int l = -1;
	for(i=0;i<(n+m);i++){
		if(BN[i] == SKUP_B && a[i][e] > 0){
			if(l == -1){
				min = b[i] / a[i][e];
				l = i;
			}
			else{
				if(b[i]/a[i][e] < min){
					min = b[i] / a[i][e];
					l = i;
				}
			}
		}
	}
	return l;
}

void pivot(int e, int l, double *v, double **a, double *b, double *c, int *BN, int n, int m){
	int i,j;
	b[e] = b[l] / a[l][e];
	for(i=0;i<(n+m);i++){
		if(BN[i] == SKUP_N && i != e){
			a[e][i] = a[l][i] / a[l][e];
		}
	}
	a[e][l] = 1/a[l][e];
	for(i=0;i<(n+m);i++){
		if(BN[i] == SKUP_B && i != l){
			b[i] = b[i] - a[i][e] * b[e];
			for(j=0;j<(n+m);j++){
				if(BN[j] == SKUP_N && j != e){
					a[i][j] = a[i][j] - a[i][e] * a[e][j];
				}
			}
			a[i][l] = -a[i][e] * a[e][l];
		}
	}
	(*v) = (*v) + c[e] * b[e];
	for(i=0;i<(n+m);i++){
		if(BN[i] == SKUP_N && i != e){
			c[i] = c[i] - c[e] * a[e][i];
		}
	}
	c[l] = -c[e] * a[e][l];	
	BN[e] = SKUP_B;
	BN[l] = SKUP_N;
}

int main(){
	
	int i;
	int e,l;
	int n,m;	//broj nepoznatih/ogranicenja
	double v = 0.0;
	
	n = 4;
	m = 5;
	
	double **a;
	double b[n+m], c[n+m], x[n+m];
	int BN[n+m];
	
	a = (double**)malloc((n+m)*sizeof(double*));
	for(i=0;i<(n+m);i++)
		a[i] = (double*)malloc((n+m)*sizeof(double));
	
	//prva mesavina
	scanf("%lf",&a[n+1][0]);	//sljiva
	scanf("%lf",&a[n+2][0]);	//kajsija
	scanf("%lf",&a[n+3][0]);	//visnja
	scanf("%lf",&a[n][0]);		//secer
	
	//druga mesavica
	scanf("%lf",&a[n+1][1]);	//sljiva
	scanf("%lf",&a[n+2][1]);	//kajsija
	a[n+3][1] = 0.0;			//visnja
	scanf("%lf",&a[n][1]);		//secer
	
	//treca mesavina
	scanf("%lf",&a[n+1][2]);	//sljiva
	a[n+2][2] = 0.0;			//kajsija
	scanf("%lf",&a[n+3][2]);	//visnja
	scanf("%lf",&a[n][2]);		//secer
	
	//cetvrta mesavina
	a[n+1][3] = 0.0;			//sljiva
	scanf("%lf",&a[n+2][3]);	//kajsija
	scanf("%lf",&a[n+3][3]);	//visnja
	scanf("%lf",&a[n][3]);		//secer
	
	for(i=n;i<(n+m-1);i++){
		scanf("%lf",&b[i]);
		c[i] = 0.0;
		BN[i] = SKUP_B;
	}
	
	for(i=0;i<n;i++){
		scanf("%lf",&c[i]);
		b[i] = 0.0;
		BN[i] = SKUP_N;
	}
	
	scanf("%lf",&b[n+m-1]);
	c[n+m-1] = 0.0;
	BN[n+m-1] = SKUP_B;
	
	//troskovi
	scanf("%lf",&a[n+4][0]);
	scanf("%lf",&a[n+4][1]);
	scanf("%lf",&a[n+4][2]);
	scanf("%lf",&a[n+4][3]);
	
	for(i=0;i<n;i++){
		c[i] = c[i] - a[n+4][i];
	}
	
	//algoritam
	while((e = nadjiUlaz(BN,c,n,m)) != -1){
		l = nadjiIzlaz(e,BN,a,b,n,m);
		if(l == -1){
			printf("Problem neogranicen.\n");
			break;
		}
		else{
			pivot(e,l,&v,a,b,c,BN,n,m);
		}
	}
	
	if(e == -1){
		for(i=0;i<n;i++){
			if(BN[i] == SKUP_B)
				x[i] = b[i];
			else
				x[i] = 0.0;
		}
		printf("%.2lf\n",v);
		for(i=0;i<n;i++)
			printf("%.2lf ",x[i]);
		printf("\n");
	}

	return 0;
}
