#include<stdio.h>
#include<stdlib.h>
#include<math.h>

typedef struct{
    int ID;
    int vreme;
    int vaznost;
    float latencija;
}proracun;

void rekonstrukcija(int **opt, int **rek, int n, int m, int *IDevi, int *nCPU, proracun *proracuni, int brojCPUInfr)
{
    int vreme;
    if(opt[n][m] > 0)
    {
        if(opt[n][m] != opt[n-1][m])
        {
            vreme = proracuni[rek[n][m]].vreme / brojCPUInfr;
            if(brojCPUInfr > 1)
                vreme += proracuni[rek[n][m]].latencija * brojCPUInfr;
            
            IDevi[(*nCPU)++] = proracuni[rek[n][m]].ID;
            rekonstrukcija(opt, rek, n - 1, m - vreme, IDevi, nCPU, proracuni, brojCPUInfr);
        }
        else
            rekonstrukcija(opt, rek, n-1, m, IDevi, nCPU, proracuni, brojCPUInfr);
    }
}

int main()
{
    int n, p, dostupnoVreme;
    int *hardInf;
    proracun *proracuni;
    int **opt, **rek;

    int brCPU, maxVaznost, *IDevi, nCPU; 

    scanf("%d", &n);
    hardInf = (int *)malloc(sizeof(int) * (n + 1));
    for(int i=1; i<=n; i++)
        scanf("%d", &hardInf[i]);
    
    scanf("%d%d", &dostupnoVreme, &p);
    proracuni = (proracun *)malloc(sizeof(proracun) * (p + 1));
    IDevi = (int *)malloc(sizeof(int) * (p + 1));

    for(int i=1; i<=p; i++)
        scanf("%d%d%d%f", &proracuni[i].ID, &proracuni[i].vreme, &proracuni[i].vaznost, &proracuni[i].latencija);
    opt = (int **)malloc(sizeof(int *) * (p + 1));
    rek = (int **)malloc(sizeof(int *) * (p + 1));
    int vreme;
    int vremeProracuna;
    dostupnoVreme *= 60;

    maxVaznost = brCPU = 0; //trenutno najveca maximalna vaznost, i broj procesora koji se koristi
    for(int k=1; k<=n; k++) //proveri svaku infrastrukturu, i odaberi jednu
    {
        vreme = dostupnoVreme / hardInf[k]; //vreme izvrsavanja paralelno
        for(int i=0; i<=p; i++)
        {
            opt[i] = (int *)malloc(sizeof(int) * (vreme + 1));
            rek[i] = (int *)malloc(sizeof(int) * (vreme + 1));
        }

        for(int i=1; i<=p; i++) //za svaki proracun
        {
            opt[i][0] = 0;
            vremeProracuna = proracuni[i].vreme / hardInf[k];
            
            if(hardInf[k] > 1)
                vremeProracuna += ceil(proracuni[i].latencija * hardInf[k]);

            for(int j=1; j<=vreme; j++)
            {
                if(j >= vremeProracuna)
                {
                    if(proracuni[i].vaznost + opt[i-1][j - vremeProracuna] > opt[i-1][j])
                    {
                        opt[i][j] = proracuni[i].vaznost + opt[i-1][j - vremeProracuna];
                        rek[i][j] = i;
                    }
                    else
                    {
                        opt[i][j] = opt[i-1][j];
                        rek[i][j] = rek[i-1][j];
                    }
                }
                else
                {
                    opt[i][j] = opt[i-1][j];
                    rek[i][j] = rek[i-1][j];
                }
            }
        }
        if(!maxVaznost || opt[p][vreme] > maxVaznost)
        {
            maxVaznost = opt[p][vreme];
            brCPU = hardInf[k];
            nCPU = 1;
            rekonstrukcija(opt, rek, p, vreme, IDevi, &nCPU, proracuni, hardInf[k]);
        }
    }
    printf("%d\n", brCPU);
    printf("%d\n", maxVaznost);
    for(int i=1; i<nCPU; i++)
        printf("%d ", IDevi[i]);
    printf("\n");
    return 0;
}