#include<stdio.h>
#include<stdlib.h>

#define INF (-1)
#define NIL (-2)

#define TRUE 1
#define FALSE 0

typedef struct{
    int pocetniGrad;
    int krajnjiGrad;
    double duzinaPuta;
    int jeAutoput;
    int cenaPutarine;
}PUT;

int je_manji(int i, int j){
    if(i == INF)
        return FALSE;
    if(j == INF)
        return TRUE;
    return i < j;
}

int nadji_min(int *obidjen, int *d, int n){
    int i;
    int min = INF;
    int minCvor = NIL;

    for(i = 0; i < n; i++){
        if(obidjen[i] == FALSE && je_manji(d[i], min)){
            min = d[i];
            minCvor = i;
        }
    }
    return minCvor;
}

void relax(int **graf, int *d, int *pret, int u, int v){
    if(je_manji(d[u] + graf[u][v], d[v])){
        d[v] = d[u] + graf[u][v];
        pret[v] = u;
    }
}

void dijkstra(int **graf, int *obidjen, int *d, int *pret, int n){
    int i, u, v;

    for(i = 0; i < n; i++){
        u = nadji_min(obidjen, d, n);
        obidjen[u] = TRUE;
        for(v = 0; v < n; v++){
            if(grav[u][v] != INF && obidjen[v] == FALSE){
                relax(graf, d, pret, u, v);
            }
        }
    }
}

int rekonstrukcija(int i, int polaziste, int *pret, int *dA, int *dRP){
    int rbr;
    if(i == polaziste){
        return -1;
    }
    else{
        rbr = rekonstrukcija(pret[i], polaziste, pret, dA, dRP);
        if(rbr == -1 && dRP[i] <= dA[i]]){
            return i;
        }
        else{
            return rbr;
        }
    }
    return -1; // Ako nije moguce posetiti
}
// Od 0 do N - 1
int main(){
    int N, M, i, j;
    int **graf;
    int *dA, *dRP, *pretA, *pretRP;
    int *obidjenA, *obidjenRP;
    double  cenaGorivaPoLitru, potrosnjaGorivaA, 
            potrosnjaGorivaRP, cenaPutovanja = 0.0, kilometrazaPutovanja = 0.0;
    PUT *putevi;
    int polaziste, odrediste;

    scanf("%lf", &cenaGorivaPoLitru);
    scanf("%lf%lf", &potrosnjaGorivaA, &potrosnjaGorivaRP);
    scanf("%d%d", &N, &M);

    graf = (int **)malloc(sizeof(int *) * M);
    for(i = 0; i < m; i++)
        graf[i] = (int *)malloc(sizeof(int) * M);
    putevi = (PUT*)malloc(sizeof(PUT) * M);

    dA = (int *)malloc(sizeof(int) * N);
    dRP = (int *)malloc(sizeof(int) * N);
    pretRP = (int *)malloc(sizeof(int) * N);
    pretA = (int *)malloc(sizeof(int) * N);
    obidjenA = (int *)malloc(sizeof(int) * N);
    obidjenRP = (int *)malloc(sizeof(int) * N);

    for(i = 0; i < N; i++){
        dA[i] = INF;
        dRP[i] = INF;
        pretA[i] = NIL;
        pretRP[i] = NIL;
        obidjenA[i] = FALSE;
        obidjenRP[i] = FALSE;
    }

    for(i = 0; i < N; i++)
        for(j = 0; j < N; j++){
            graf[i][j] = INF;
        }

    for(i = 0; i < n; i++){
        scanf("%d%d%lf%d",  &putevi[i].pocetniGrad, 
                            &putevi[i].krajnjiGrad,
                            &putevi[i].duzinaPuta,
                            &putevi[i].jeAutoput);
        if(putevi[i].jeAutoput == TRUE){
            scanf("%lf", &putevi[i].cenaPutarine);
        }
        else{
            putevi[i].cenaPutarine = -1;
        }
    }

    dRP[polaziste] = 0
    dA[odrediste] = 0;

    dijkstra(graf, obidjenA, dA, pretA, N);
    dijkstra(graf, obidjenRP, dRP, pretRP, N);

    if(rekonstrukcija(graf, polaziste, pretA, int *dRP, int *dA) == -1){
        printf("-1");
    }
    else{

        for(i = 0; i < N; i++){
            cenaPutovanja += putevi[i].cenaPutarine + 
                putevi[i].cenaGorivaPoLitru * putevi[i].duzinaPuta;
        }


        printf("%lf", cenaPutovanja);
        printf("%lf", kilometrazaPutovanja);
        
        printf("%d ", polaziste);
        for(i = 0; i < N; i++)
            printf("%d ", obidjenA[i]);
        printf("%d ",odrediste);
        for(j = 0; j < M; j++)
            printf("%d ", obidjenRP[i + j]);
        printf("%d ", polaziste);

    }



}