#include <stdio.h>
#include <stdlib.h>

//autoput - 1
//regionalni put - 0

#define TRUE 1
#define FALSE 0
#define INF (-1)
#define NILL (-1)

typedef struct{
	int u, v;
	double w, udaljenost;
	int tipPuta;
	int brVeza, posecen;
}Veza;

int manji(int x, int y){
	if(x==INF) return TRUE;
	if(y==INF) return FALSE;
	return x<y;
}

int nadjiMin(int *obidjen, int *d, int n){
	int i, min=INF, minCvor=0;
	for(i=0; i<n; i++)
		if(obidjen[i]==FALSE && manji(d[i], min)){
			min = d[i];
			minCvor = i;
		}
	return minCvor;
}

void relax(Veza **graf, int *d, int *preth, int u, int v){
	if(manji(d[u]+graf[u][v].w, d[v])){
		d[v]=d[u]+graf[u][v].w;
		preth[v] = u;
	}
}

void dijkstra(Veza **graf, int *d, int *preth, int n, int *obidjen, double *udaljenost, double *cena){
	int i, u, v, j, pomV;
	/*for(i=0; i<n; i++){
		u = nadjiMin(obidjen, d, n);
		obidjen[u] = TRUE;
		for(v=0; v<n; v++)
			if(graf[u][v]!=INF && obidjen[v]==FALSE)
				relax(graf, obidjen, d, preth, u, v);
	}*/
	for(i=0; i<n; i++){
		u = nadjiMin(obidjen, d, n);
		for(v=0; v<n; v++){
			if(obidjen[v]==FALSE && graf[u][v].posecen==0) {
				if(graf[u][v].brVeza>1 && graf[u][v].w!=INF){
					for(j=0; j<graf[u][v].brVeza; j++){
						if(u==i && v==j){
							if(graf[u][v].w < graf[u][j].w)
								pomV = v;
							else
								pomV=j;
						}
					}
					v = pomV;
					graf[u][v].posecen = graf[v][u].posecen = 1;
				}
				relax(graf, d, preth, u, v);
				//printf("%d %d %lf %lf\n", u, v, graf[u][v].udaljenost, graf[u][v].w);
				(*udaljenost) += graf[u][v].udaljenost;
				(*cena) += graf[u][v].w;
			}
		}
	}
}

int rekonstrukcija(int i, int polaziste, int *preth, int *d){
	int rbr;
	if(i==polaziste) return -1;
	rbr = rekonstrukcija(i, polaziste, preth, d);
	if(rbr==-1 && d[i]<0) return i;
	else return rbr;
}

int main(){
	Veza **graf;
	double potrosnjaAutoput, potrosnjaRegionalniPut, cenaGoriva, putarina, cenaPutovanja=0.0, kilometrazaPutovanja=0.0;
	int n, m, u, v, polaziste, odrediste, *obidjen, put, *d, *dp, *preth, duzina; //dp-povratak
	int i, j;
	
	scanf("%lf%lf%lf", &cenaGoriva, &potrosnjaAutoput, &potrosnjaRegionalniPut);
	scanf("%d%d", &n, &m);
	potrosnjaAutoput /= 100;
	potrosnjaRegionalniPut /= 100;
	graf = (Veza**)malloc(m*sizeof(Veza*));
	obidjen = (int*)malloc(m*sizeof(int));
	d = (int*)malloc(m*sizeof(int));
	dp = (int*)malloc(m*sizeof(int));
	preth = (int*)malloc(m*sizeof(int));
	for(i=0; i<n; i++){
		graf[i] = (Veza*)malloc(n*sizeof(Veza));
		obidjen[i] = FALSE;
		d[i] = INF;
		dp[i] = INF;
		preth[i] = NILL;
	}

	for(i=0; i<n; i++){
		for(j=0; j<n; j++){
			graf[i][j].w = INF;
			graf[i][j].brVeza = graf[j][i].brVeza = 0;
			graf[i][j].posecen = graf[j][i].posecen = 0;
		}
	}
	
	for(i=0; i<m; i++){
		scanf("%d%d%d%d", &u, &v, &duzina, &put); //printf("----- %d %d %d %d ", u, v, duzina, put);
		graf[u][v].tipPuta = graf[v][u].tipPuta = put;
		graf[u][v].udaljenost = graf[v][u].udaljenost = duzina;
		if(put==1) scanf("%lf", &putarina); //autoput
		else putarina=0; //regionalni put
		//printf(" %lf\n", putarina);
		graf[u][v].brVeza = 1;
		for(j=0; j<n; j++)
			if(i==u && j==v)
				graf[u][v].brVeza++;
		graf[u][v].w = duzina * cenaGoriva*potrosnjaAutoput+ putarina;
	}
	
	scanf("%d%d", &polaziste, &odrediste);
	
	d[polaziste]=0;
	d[odrediste]=0;
	
	dijkstra(graf, d, preth, n, obidjen, &kilometrazaPutovanja, &cenaPutovanja);
	
	obidjen[polaziste]=0;
	obidjen[odrediste]=0;
	
	dijkstra(graf, dp, preth, n, obidjen, &kilometrazaPutovanja, &cenaPutovanja);
	
	printf("%.4lf\n%.4lf\n", cenaPutovanja, kilometrazaPutovanja);
	printf("%d  ", polaziste);
	/*int putRek;
	for(i=0; i<n; i++){
		putRek = rekonstrukcija(i, polaziste, preth, d);
		printf("%d  ", putRek);
	}	
	for(i=0; i<n; i++){
		putRek = rekonstrukcija(i, odrediste, preth, dp);
		printf("%d  ", putRek);
	}*/
	rekonstrukcija(i, polaziste, preth, d);
	rekonstrukcija(i, odrediste, preth, dp);
	printf("%d  %d\n", odrediste, polaziste);
	
		
}
