#include <stdio.h>
#include <stdlib.h>

#define NILL -1
#define INF -1

#define TRUE 1
#define FALSE 0

typedef struct veza{
        double duzina;
        double cena;
}veza;

int jeManji(int a, int b){
        if(a==INF){
                return FALSE;
        }else if(b==INF){
                return TRUE;
        }else{
                return a<b;
        }
}

int dajNajboljeg(int *d, int *obidjen, int n){
        int min=INF;
        int minCvor=NILL;
        int i;
        
        for(i=0;i<n;i++){
                if(obidjen[i]==FALSE && jeManji(d[i], min)){
                        minCvor=i;
                        min=d[i];
                }
        }
        return minCvor;
}

void relax(veza **graf, int *d, int *pret, int u, int v){
        if(jeManji(d[u]+graf[u][v].cena, d[v])){
                d[v]=d[u]+graf[u][v].cena;
                pret[v]=u;
        }
}

void dijkstra(veza **graf, int *d, int *obidjen, int *pret, int n){
        int u,v,i;
        
        for(i=0;i<n;i++){
                u=dajNajboljeg(d,obidjen,n); 
                obidjen[u]=TRUE;
                for(v=0;v<n;v++){
                        if(obidjen[v]==FALSE && graf[u][v].duzina!=INF && graf[u][v].cena!=INF){
                                relax(graf,d,pret,u,v);
                        }
                }
                
        }
}

void stampajPut(int *pret, int a, int b){
        if(a==b){
                printf("%d\n", a);
                return;
        }else if(pret[b]==NILL){
                printf("-1\n");
                return;
        }else{
                stampajPut(pret, a, pret[b]);
                printf("%d\n", b);
        }
}

int main(){
        int n,m,u,v,i,j;
        veza **graf;
        int *d, *pret, *obidjen;
        double cenaGoriva, l, autoput, putarina, cenaPutovanja, kilometrazaPutovanja;
        double potrosnjaGorivaAutoput, potrosnjaGorivaRegionalni;
        scanf("%d%d", &n, &m);
        scanf("%lf%lf", &potrosnjaGorivaAutoput, &potrosnjaGorivaRegionalni);
        
        graf=(veza **)malloc(sizeof(veza *)*(n+1));
        d=(int *)malloc(sizeof(int)*(n+1));
        pret=(int *)malloc(sizeof(int)*(n+1));
        obidjen=(int *)malloc(sizeof(int)*(n+1));
        
        for(i=0;i<n;i++){
                graf[i]=(veza *)malloc(sizeof(veza)*(n+1));
                d[i]=INF;
                pret[i]=NILL;
                obidjen[i]=FALSE;
        }
        
        for(i=0;i<n;i++){
                for(j=0;j<n;j++){
                        graf[i][j].duzina=INF;
                        graf[i][j].cena=INF;
                } 
        }

        for(i=0;i<m;i++){
             scanf("%d%d%lf%lf", &u, &v, &l, &autoput);
             if(autoput==1){
                     scanf("%lf", &putarina);
                     graf[u][v].duzina=l;
                     graf[u][v].cena=l/100*potrosnjaGorivaAutoput*cenaGoriva+putarina;
                     
                     graf[v][u].duzina=l;
                     graf[v][u].cena=l/100*potrosnjaGorivaAutoput*cenaGoriva+putarina;
             }
             
             
             graf[u][v].duzina=l;
             graf[u][v].cena=l/100*potrosnjaGorivaRegionalni*cenaGoriva;
             
             graf[v][u].duzina=l;
             graf[v][u].cena=l/100*potrosnjaGorivaRegionalni*cenaGoriva;
        }
        
        int polaziste, odrediste;
        
        d[polaziste]=0;
        
        dijkstra(graf, d, obidjen, pret, n);
        stampajPut(pret, polaziste, odrediste);
}
