#include <stdio.h>
#include <stdlib.h>

#define NILL -1
#define INF -1
#define true 1
#define false 0


double ukupnaCena = 0, ukupnaKilometraza = 0;
double **kilometraza;
int jeManji(int i, int j){
	if(i == INF)
		return false;
	if(j == INF)
		return true;
		
	return i<j;
}

int nadjiMin(double *d, int *obidjen, int n){
	int i;
	double min = INF;
	int minCvor;
	
	for(i=0;i<n;i++){
		if(obidjen[i] == false && jeManji(d[i],min) ){
			min = d[i];
			minCvor = i;
		}
		
	}
	return minCvor;
}

void relax(double **graf, double *d, int *pret, int u, int v){
	if(jeManji(graf[u][v] + d[u], d[v])){
		d[v] = graf[u][v] + d[u];
		pret[v] = u;
		
	}
	
}

void dijkstra(double **graf, double *d, int *pret, int *obidjen,int n){
	int i;
	int u, v;
	for(i=0;i<n;i++){
		u = nadjiMin(d, obidjen, n);
		obidjen[u] = true;
		for(v=0;v<n;v++){
			if(graf[u][v]!=INF && obidjen[v] == false )
				relax(graf, d, pret,u,v);
			
		}
		
	}
}

void rekonstukcija(int *pret, int v,int s, double **graf, int sig){
	if(s==v){
		if(sig){
			printf("%d ", s);
			
			graf[s][v] = INF;
			graf[v][s] = INF;
		}
	}
	else if(pret[v] == NILL)
		printf("-1 ");
	else{
		rekonstukcija(pret, pret[v], s,  graf, sig);
		printf("%d ", v);
		graf[pret[v]][v] = INF;
		graf[v][pret[v]] = INF;
		
		ukupnaKilometraza+=kilometraza[pret[v]][v];
		
	}
}


int main(){
	double **graf;
	int *pret;
	double *d;
	int *obidjen;
	int put;
	double putarina;
	double l;
	int u, v;
	double cenaGoriva;
	double potrosnjaA, potrosnjaR;
	int n, m , i ,j;
	double potrosnja;
	int polaziste, odrediste;
	
	scanf("%lf", &cenaGoriva);
	scanf("%lf%lf", &potrosnjaA, &potrosnjaR);
	
	scanf("%d%d", &n, &m);
	
	graf = (double **)malloc(n*sizeof(double *));
	
	pret = (int *)malloc(n*sizeof(int ));
	obidjen = (int *)malloc(n*sizeof(int ));
	d = (double *)malloc(n*sizeof(double ));
	kilometraza = (double **)malloc(n*sizeof(double *));
	
	for(i=0;i<n;i++){
		kilometraza[i] = (double *)malloc(n*sizeof(double));
		graf[i] = (double *)malloc(n*sizeof(double));
		
	}
	
	for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			graf[i][j] = INF;
			kilometraza[i][j] = INF;
			
		}
		obidjen[i] = false;
		pret[i] = NILL;
		d[i] = INF;
		
	}

	
	for(i=0;i<m;i++){
		scanf("%d%d%lf%d", &u, &v, &l, &put);
		
		if(put){
			scanf("%lf", &putarina);
			potrosnja = (potrosnjaA*l)/100 * cenaGoriva + putarina;
		}
		else{
			potrosnja = (potrosnjaR*l)/100 * cenaGoriva;
		}
		if(graf[u][v] != INF && graf[v][u]!=INF){
			if(graf[u][v] > potrosnja){
				kilometraza[u][v] = l;
				kilometraza[v][u] = l;
				
				graf[u][v] = potrosnja;
				graf[v][u] = potrosnja;
			}
		}
		else{
			kilometraza[u][v] = l;
			kilometraza[v][u] = l;
				
			graf[u][v] = potrosnja;
			graf[v][u] = potrosnja;
		}
		
	}
	scanf("%d%d", &polaziste, &odrediste);
	
	
	d[polaziste] = 0;
	dijkstra(graf, d, pret, obidjen, n );
	ukupnaCena += d[odrediste];
	rekonstukcija(pret, odrediste, polaziste, graf, 1);

	for(i=0;i<n;i++){
		obidjen[i] = false;
		pret[i] = NILL;
		d[i] = INF;
	}
	
	d[odrediste] = 0;
	dijkstra(graf, d, pret, obidjen, n);
	ukupnaCena+=d[polaziste];
	
	
	rekonstukcija(pret, polaziste, odrediste, graf, 0);
	
	
	printf("\n");
	
	printf("%.3lf\n", ukupnaCena);
	printf("%.3lf\n", ukupnaKilometraza);
	printf("\n");
	
	
	
}
