#include<stdio.h>
#include<stdlib.h>

#define INF -1
#define NILL -1
#define TRUE 1
#define FALSE 0


int jeManji(int i,int j)
{
	if(i == INF)
		return FALSE;
	if(j == INF)
		return TRUE;
	return i<j;
}

int nadjiMin(int n,int *obidjeni,float *d)
{
	int min = INF;
	int index = NILL;
	
	for(int i = 0;i < n;i++)
	{
		if(obidjeni[i] == FALSE && jeManji(d[i],min))
		{
			min = d[i];
			index = i;
		}
	}
	return index;
	
}

void relax(int u,int v,float *d,int **mat,int *p)
{
	if(jeManji(d[u] + mat[u][v],d[v]))
	{
		d[v] = d[u] + mat[u][v];
		p[v] = u;	
	}
	
}

int dijkstra(int n,int **mat,int *obidjeni,float *d,int *p,int odrediste)
{
	int u;
	
	for(int i = 0;i < n;i++)
	{
		u = nadjiMin(n,obidjeni,d);
		if(u == odrediste)
			break;
		//printf("%d ",u);
		if(u == -1)
		{
			return -1;
			break;
		}
		obidjeni[u] = TRUE;
		for(int v = 0;v < n;v++)
		{
			if(obidjeni[v] == FALSE && mat[u][v] != INF)// nije obidjen a spojeni
			{
				relax(u,v,d,mat,p);
			}
		}
	}
	return 0;
	
}
void rekonstrukcija(int u,int v,int *p)
{
	if(u == v)
	{
		printf("%d ",u);
		return;
	}else if(p[v] == NILL)
	{
		printf("Nema putanje do tog cvora");
		return;
	}
	rekonstrukcija(u,p[v],p);
	printf("%d ",v);
	
}
void osvezi(int u,int v,int *p,int *obidjeni)
{
	if(u == v)
	{
		obidjeni[u] = TRUE;
		return;
	}else if(p[v] == NILL)
	{
		return;
	}
	osvezi(u,p[v],p,obidjeni);
	obidjeni[v] = TRUE;
	
}
int main()
{

	int **mat,**kilometraza;
	int *p,*obidjeni;
	float *d,cena = 0;
	float cenaGoriva,potrosnjaGorivaAutoPut,potrosnjaGorivaRegionalniPut;


	int n,m,u,v,w,l,put,putarina,polaziste,odrediste,vrati;
	scanf("%f %f %f",&cenaGoriva,&potrosnjaGorivaAutoPut,&potrosnjaGorivaRegionalniPut);
	scanf("%d %d\n",&n,&m);
	
	
	mat = (int **)malloc(n*sizeof(int*));
	kilometraza = (int **)malloc(n*sizeof(int*));
	
	for(int i = 0;i < n;i++)
	{
		mat[i] = (int *)malloc(n*sizeof(int*));
		kilometraza[i] = (int *)malloc(n*sizeof(int*));
	}
	
	p = (int *)malloc(n*sizeof(int));
	obidjeni = (int *)malloc(n*sizeof(int));
	d = (float *)malloc(n*sizeof(float));
	
	for(int i = 0;i < n;i++)
	{
		d[i] = INF;
		p[i] = NILL;
		obidjeni[i] = FALSE;
	}
	
	for(int i = 0;i < n;i++)
		for(int j = 0;j < n;j++)
		{
			mat[i][j] = INF;
			kilometraza[i][j] = INF;
		}
		
	for(int i = 0;i < m;i++)
	{
		scanf("%d %d %d %d",&u,&v,&l,&put);
		if(put == 1)
			scanf("%d ",&putarina);
		if( put == 1) // autoput
			w = l/potrosnjaGorivaAutoPut + putarina;
		else
			w = l/potrosnjaGorivaRegionalniPut;
		
		if(mat[u][v] == -1 || mat[u][v] > w)
		{
			mat[u][v] = w;	
			kilometraza[u][v] = l;
			mat[v][u] = w;
			kilometraza[v][u] = l;
		}	
	}
	
	scanf("%d %d",&polaziste,&odrediste);
	
	d[polaziste] = 0;
	
	vrati = dijkstra(n,mat,obidjeni,d,p,odrediste);
	if(vrati == -1)
		printf("Prvi -1");
	else
	{
	//	printf("\n"); //
	//	rekonstrukcija(polaziste,odrediste,p);//

		for(int i = 0;i < n;i++)
		{
			obidjeni[i] = FALSE;
		}
		osvezi(polaziste,odrediste,p,obidjeni);
		/*
		for(int i = 0;i < n;i++)
			printf(" %d ",obidjeni[i]);
		*/
		
		
		vrati = 0;
		obidjeni[polaziste] = FALSE;
		obidjeni[odrediste] = FALSE;
		
		d[odrediste] = 0;
		d[polaziste] = INF;
		//printf("D:\n");
		/*
		for(int i = 0;i < n;i++)
			printf("%2.3lf ",d[i]);
		printf("\n");
		*/
		vrati = dijkstra(n,mat,obidjeni,d,p,polaziste);
		
		if(vrati == -1)
			printf("Drugi -1");
		else
		{
			
			for(int i = 0;i < n;i++)
			{
				d[i] = INF;
				p[i] = NILL;
				obidjeni[i] = FALSE;
			}
			obidjeni[polaziste] = FALSE;
			obidjeni[odrediste] = FALSE;
			d[polaziste] = 0;
			vrati = dijkstra(n,mat,obidjeni,d,p,odrediste);
			cena += d[odrediste];
			//rekonstrukcija(polaziste,odrediste,p);
			
			for(int i = 0;i < n;i++)
			{
				obidjeni[i] = FALSE;
			}
			osvezi(polaziste,odrediste,p,obidjeni);

			vrati = 0;
			obidjeni[polaziste] = FALSE;
			obidjeni[odrediste] = FALSE;
			
			d[odrediste] = 0;
			d[polaziste] = INF;
			
			vrati = dijkstra(n,mat,obidjeni,d,p,polaziste);
			cena += d[polaziste];
			//rekonstrukcija(odrediste,polaziste,p);
			printf("%4.4f\n",cena);
			
			
			for(int i = 0;i < n;i++)
			{
				d[i] = INF;
				p[i] = NILL;
				obidjeni[i] = FALSE;
			}
			obidjeni[polaziste] = FALSE;
			obidjeni[odrediste] = FALSE;
			d[polaziste] = 0;
			vrati = dijkstra(n,mat,obidjeni,d,p,odrediste);
			
			rekonstrukcija(polaziste,odrediste,p);
			
			for(int i = 0;i < n;i++)
			{
				obidjeni[i] = FALSE;
			}
			osvezi(polaziste,odrediste,p,obidjeni);

			vrati = 0;
			obidjeni[polaziste] = FALSE;
			obidjeni[odrediste] = FALSE;
			
			d[odrediste] = 0;
			d[polaziste] = INF;
			
			vrati = dijkstra(n,mat,obidjeni,d,p,polaziste);
			//rekonstrukcija(odrediste,polaziste,p);
			
		}
			
	}	
	
	
}
