#include<stdio.h>
#include<stdlib.h>

#define INF -1
#define UND -1
#define TRUE 1
#define FALSE 0

int jeManji(float a, float b){
    if(a==INF) return FALSE;
    if(b==INF) return TRUE;
    return a<b;
}

int nadjiMinimum(float* udaljenost, int brojGradova,int* obidjen){
    int i,minGrad=UND;
    float minUdaljenost=INF;
    for(i=0;i<brojGradova;i++){
        if(jeManji(udaljenost[i],minUdaljenost) && obidjen[i]==FALSE){
            minUdaljenost=udaljenost[i];
            minGrad=i;
        }
    }
    return minGrad;
}

void relax(int trenutni, int susedni, float* udaljenost, float** matrica, int* prethodnik){

    if(jeManji(udaljenost[trenutni]+matrica[trenutni][susedni],udaljenost[susedni])){
        udaljenost[susedni]=udaljenost[trenutni]+matrica[trenutni][susedni];
        prethodnik[susedni]=trenutni;
    }
}

void dijkstra(float** matrica, int* prethodnik,float* udaljenost, int brojGradova, int* obidjen,int*posecen){
    int i,trenutni,susedni;
    for(i=0;i<brojGradova;i++){
        trenutni=nadjiMinimum(udaljenost,brojGradova,obidjen);
        obidjen[trenutni]=TRUE;
        for(susedni=0;susedni<brojGradova;susedni++){
            if(matrica[trenutni][susedni]!=INF && obidjen[susedni]==FALSE && posecen[susedni]==FALSE){
				
                relax(trenutni,susedni,udaljenost,matrica,prethodnik);
            }
        }
    }
}


int main(){
    float** matrica;
    float cenaGoriva;
    float potrosnjaAuto;
    float potrosnjaReg;
    int *obidjen1,*obidjen2;
    int* posecen;
    int* prethodnik1,*prethodnik2;
    float *udaljenost1;
    float *udaljenost2;
    int brojGradova;
    int brojPuteva;
    int pocetak,kraj;
    int i,j;
  
    scanf("%f%f%f",&cenaGoriva,&potrosnjaAuto,&potrosnjaReg);
    scanf("%d%d",&brojGradova,&brojPuteva);
    matrica=(float**)malloc(brojGradova*sizeof(float*));
    obidjen1=(int*)malloc(brojGradova*sizeof(int));
    obidjen2=(int*)malloc(brojGradova*sizeof(int));
    posecen=(int*)malloc(brojGradova*sizeof(int));
    prethodnik1=(int*)malloc(brojGradova*sizeof(int));
    prethodnik2=(int*)malloc(brojGradova*sizeof(int));
    udaljenost1=(float*)malloc(brojGradova*sizeof(float));
    udaljenost2=(float*)malloc(brojGradova*sizeof(float));

    for(i=0;i<brojGradova;i++){
        matrica[i]=(float*)malloc(brojGradova*sizeof(float));
        obidjen1[i]=FALSE;
        obidjen2[i]=FALSE;
        posecen[i]=FALSE;
        prethodnik1[i]=UND;
        prethodnik2[i]=UND;
        udaljenost1[i]=INF;
        udaljenost2[i]=INF;
        for(j=0;j<brojGradova;j++){
            matrica[i][j]=INF;
        }
    }
    


    for(i=0;i<brojPuteva;i++){
        int grad1,grad2,autoput;
        float duzina,putarina;
        float cena;
        scanf("%d%d%f%d",&grad1,&grad2,&duzina,&autoput);
        if(autoput==TRUE){
            scanf("%f",&putarina);
            cena=putarina;
            cena+=duzina/100*potrosnjaAuto*cenaGoriva;
        }
        else{
            cena=duzina/100*potrosnjaReg*cenaGoriva;
        }
        matrica[grad1][grad2]=cena;
        matrica[grad2][grad1]=cena;
    }
    
    scanf("%d%d",&pocetak,&kraj);
    udaljenost1[pocetak]=0;
    dijkstra(matrica,prethodnik1,udaljenost1,brojGradova,obidjen1,posecen);
    if(udaljenost1[kraj]!=INF){
        for(i=0;i<brojGradova;i++){
            if(prethodnik1[i]!=UND){
                posecen[prethodnik1[i]]=TRUE;
            }
        }
        posecen[pocetak]=FALSE;
        posecen[kraj]=FALSE;
    }
    udaljenost2[kraj]=0;
    dijkstra(matrica,prethodnik2,udaljenost2,brojGradova,obidjen2,posecen);
    
}
