#include<stdio.h>
#include<stdlib.h>

#define INF -1
#define NILL -1

int jeManji(int a, int b) {
	if(a == INF)
		return 0;
	if(b == INF)
		return 1;
	else
		return a < b;
}

int nadjiMin(int *obidjen, int *d, int n) {
	int min = INF;
	int minCvor = NILL;
	int i;

	for(i = 0; i < n; i++) {
		if(!obidjen[i] && jeManji(d[i], min)) {
			min = d[i];
			minCvor = i;
		}
	}

	return minCvor;
}

void relax(double **graf, int *pret, int *d, int n, int u, int v) {
	if(jeManji(graf[u][v] + d[u], d[v])) {
		d[v] = graf[u][v] + d[u];
		pret[v] = u;
	}
}

void dijkstra(double **graf, int *d, int *pret, int *obidjen, int n) {
	int i, u, v;

	for(i = 0; i < n; i++) {
		u = nadjiMin(obidjen, d, n);
		obidjen[u] = 1;
		for(v = 0; v < n; v++)
			if(!obidjen[i] && graf[u][v] != INF)
				relax(graf, pret, d, n, u, v);
	}
}

/*void rekonstrukcija(int *pret, int s, int v) {
	if(s == v)
		printf("%d ", s);
	else if(pret[v] == NILL)
		printf("Nema puta od %d do %d\n", s, v);
	else {
		rekonstrukcija(pret, s, pret[v]);
		printf("%d", v);
	}
}*/

int main(void) {
	double cenaGoriva; // u test primeru nije celobrojna vrednost, u tekstu pise da jeste
	double potrosnjaAutoput, potrosnjaRegionalni;
	double l;
	double  **graf, **putarina;
	
	int *dPrvi, *pretPrvi, *obidjenPrvi;
	int *dDrugi, *pretDrugi, *obidjenDrugi;
	int **vrstaPuta;
	int n, m;
	//int vrstaPuta;
	int i, j, s, e, u, v;
	//double ukupnaCena = 0;
	//double kilometrazaPuta = 0;
	

	scanf("%lf", &cenaGoriva);
	scanf("%lf%lf", &potrosnjaAutoput, &potrosnjaRegionalni);
	scanf("%d%d", &n, &m);

	graf = (double **)malloc(n * sizeof(double *));
	vrstaPuta = (int **)malloc(n * sizeof(int *));
	putarina = (double **)malloc(n * sizeof(double *));

	dPrvi = (int *)malloc(n * sizeof(int));
	dDrugi = (int *)malloc(n * sizeof(int));

	pretPrvi = (int *)malloc(n * sizeof(int));
	pretDrugi = (int *)malloc(n * sizeof(int));

	obidjenPrvi = (int *)malloc(n * sizeof(int));
	obidjenDrugi = (int *)malloc(n * sizeof(int));

	for(i = 0; i < n; i++) {
		graf[i] = (double *)malloc(n * sizeof(double));
		vrstaPuta[i] = (int *)malloc(n * sizeof(int));
		putarina[i] = (double *)malloc(n * sizeof(double));

		for(j = 0; j < n; j++)
			graf[i][j] = INF;

		dPrvi[i] = INF;
		dDrugi[i] = INF;
		pretPrvi[i] = NILL;
		pretDrugi[i] = NILL;
		obidjenPrvi[i] = NILL;
		obidjenDrugi[i] = NILL;
	}

	for(i = 0; i < m; i++) {
		scanf("%d%d%lf", &u, &v, &l);

		graf[u][v] = l;

		scanf("%d", &vrstaPuta[u][v]);
		if(vrstaPuta[u][v])
			scanf("%lf", &putarina[u][v]);
	}

	/*for(i = 0; i < n; i++) {
		for(j = 0; j < n; j++) {

			if(graf[i][j] != -1) {
				printf("%d-%d\t%.2lf %d ", i, j, graf[i][j], vrstaPuta[i][j]);
				if(vrstaPuta[i][j])
					printf("%.2lf\n", putarina[i][j]);
				else
					printf("\n");
			}
		
		}
	}*/

	scanf("%d%d", &s, &e);

	//printf("\n");

	dPrvi[s] = 0;
	dijkstra(graf, dPrvi, pretPrvi, obidjenPrvi, n);

	/*for(i = 0; i < n; i++)
		printf("%d ", dPrvi[i]);*/

	//rekonstrukcija(pretPrvi, s, e);

	//printf("\n");

	dDrugi[e] = 0;
	dijkstra(graf, dDrugi, pretDrugi, obidjenDrugi, n);

	/*for(i = 0; i < n; i++)
		printf("%d ", dDrugi[i]);*/

	//rekonstrukcija(pretDrugi, e, s);
	
	/*for(i = 0; i < n; i++)
		for(j = 0; j < n; j++)
			ukupnaCena += cenaGoriva * (vrstaPuta[i][j] ? ((potrosnjaAutoput/100 * graf[i][j]) + putarina[i][j]) : ((potrosnjaRegionalni/100) * graf[i][j]) );

	for(i = 0; i < n; i++)
		for(j = 0; j < n; j++)
			kilometrazaPuta += graf[i][j];
			
	printf("\n%.4lf\t%.4lf", ukupnaCena, kilometrazaPuta);*/
}
