#include<stdio.h>
#include<stdlib.h>
#define NEDEFINISANO -1
#define INF -1
#define TRUE 1
#define FALSE 0
int manji(int i, int j)
{
    if(i==INF)
        return FALSE;
    if(j==INF)
        return TRUE;
    else return (i<j);  
}
int dajNajmanji(double *d, int *obidjen, int n)
{
    int minCvor=NEDEFINISANO, i;
    double min=INF;

    for(i=0;i<n;i++)
    {
        if(obidjen[i]==FALSE && manji(d[i], min))
        {
            min=d[i];
            minCvor=i;
        }
    }
    return minCvor;
}
void relax(double **graf, double *d, int *pret, int u, int v)
{
    if(manji(d[u]+graf[u][v], d[v]))
    {
        d[v]=d[u]+graf[u][v];
        pret[v]=u;
    }
}
void dijkstra(double **graf, double *d, int *pret, int *obidjen, int n, int *prosli)
{
    int v, i, u;
    for(i=0;i<n;i++)
    {
        u=dajNajmanji(d, obidjen, n);
        obidjen[u]=TRUE;
        for(v=0;v<n;v++)
        {
            if(graf[u][v]!=INF && obidjen[v]==FALSE && prosli[v]==FALSE)
                relax(graf, d, pret, u, v);
        }
    }
}
int main()
{
    double cenaGoriva, potrosnjaGorivaAutoput, potrosnjaGorivaRegPut;
    double troskovi, l, putarina, cenaPutovanja, kilometrazaPutovanja=0.0;
    double **graf, *d, **kilometraza;
    int n, m, i, j, u, v, put, polaziste, odrediste;
    int *pretOdlazak, *pretPovratak, *obidjen, *prosli;

    scanf("%lf%lf%lf", &cenaGoriva, &potrosnjaGorivaAutoput, &potrosnjaGorivaRegPut);
    scanf("%d%d", &n, &m);

    graf=(double**)malloc(n*sizeof(double*));
    d=(double*)malloc(n*sizeof(double));
    kilometraza=(double**)malloc(n*sizeof(double*));
    pretOdlazak=(int*)malloc(n*sizeof(int));
    pretPovratak=(int*)malloc(n*sizeof(int));
    obidjen=(int*)malloc(n*sizeof(int));
    prosli=(int*)malloc(n*sizeof(int));
    
    for(i=0;i<n;i++)
    {
        graf[i]=(double*)malloc(n*sizeof(double));
        kilometraza[i]=(double*)malloc(n*sizeof(double));
    }
    for(i=0;i<n;i++)
    {
        for(j=0;j<n;j++)
        {
            graf[i][j]=INF;
            kilometraza[i][j]=INF;
        }
        pretOdlazak[i]=NEDEFINISANO;
        d[i]=NEDEFINISANO;
        obidjen[i]=FALSE;
        prosli[i]=FALSE;
    }
    
    for(i=0;i<m;i++)
    {
        scanf("%d%d%lf", &u, &v, &l);
        if(kilometraza[u][v]==INF)
            kilometraza[u][v]=kilometraza[v][u]=l;
        scanf("%d", &put);
        if(put==1)
        {
            scanf("%lf", &putarina);
            troskovi=((l*potrosnjaGorivaAutoput)/100)*cenaGoriva+putarina;
        }
        else 
            troskovi=((l*potrosnjaGorivaRegPut)/100)*cenaGoriva;
        if(manji(troskovi, graf[u][v]))
        {
            graf[u][v]=graf[v][u]=troskovi;
            kilometraza[u][v]=kilometraza[v][u]=l;
        }
    }
    scanf("%d%d", &polaziste, &odrediste);
    
    
    d[polaziste]=0;
    dijkstra(graf, d, pretOdlazak, obidjen, n, prosli);

    i=odrediste;
    while(i!=polaziste)
    {
        prosli[i]=TRUE;
        kilometrazaPutovanja+=kilometraza[i][pretOdlazak[i]];
        i=pretOdlazak[i];
    }
    cenaPutovanja=d[odrediste];

    for(i=0;i<n;i++)
    {
        d[i]=INF;
        obidjen[i]=FALSE;
        pretPovratak[i]=NEDEFINISANO;
    }

     d[odrediste]=0;
     dijkstra(graf, d, pretPovratak, obidjen, n, prosli); 
     cenaPutovanja+=d[polaziste];
     i=polaziste;
     while(i!=odrediste)
     {
         kilometrazaPutovanja=kilometraza[i][pretPovratak[i]];
         i=pretPovratak[i];
     }
     printf("%lf\n", cenaPutovanja);
     printf("%lf\n", kilometrazaPutovanja);
}