#include <stdio.h>
#include <string.h>
#include <stdlib.h>
typedef struct 
{
	int u,v;
	int vred;
	double duzina;
	int autoput;
	double putarina;
}Veza;
int jeManji(int i,int j)
{
	if(i==-1) return 0;
	if(j==-1) return 1;
	return i<j;
}
int nadjiMinimum(int *obidjen,int *d,int n)
{
	int min=-1;
	int minCvor=-1;
	int i,j;
	for(i=0;i<n;i++)
	{
		if(obidjen[i]==0 && jeManji(d[i],min))
		{
			min=d[i];
			minCvor=i;
		}		
	}
	return minCvor;	
}



void relax(Veza **graf,int *d,int *pret,int n,int u,int v)
{
	if(jeManji(graf[u][v].vred+d[u],d[v]))
	{
		d[v]=graf[u][v].vred+d[u];
		pret[v]=u;
	}
}

void dijkstra(Veza **graf,int *obidjen,int *d,int *pret,int n)
{
	int i,u,v;
	for(i=0;i<n;i++)
	{
		u=nadjiMinimum(obidjen,d,n);
		obidjen[u]=1;
		//printf("\n%d\n",u);
		for(v=0;v<n;v++)
		{
			if(graf[u][v].vred!=-1 && obidjen[v]==0)
			{
				relax(graf,d,pret,n,u,v);
			}
		}
	}
}

int skloniPoseceneGradove(Veza **graf,int *d,int *pret,int n,int i,int polaziste)
{
	int br=0,j;
	if(i==polaziste) return 0;
	else
	{
		br=skloniPoseceneGradove(graf,d,pret,n,pret[d[i]],polaziste);
		br+=d[i];
			for(j=0;j<n;j++)
			{
				if(graf[i][j].vred!=-1)
				{
					graf[i][j].vred=-1;
				}
			}
		return br;
	}
}

int main()
{
	int **graf,*pret,*d,*obidjen,*pretPovratak,*dPovratak,*obidjenPovratak;
	int polaziste,odrediste;
	Veza **veze;
	
	int i,j,n,m,u,v,autoput;
	double l,putarina;
	double cenaGoriva,ppgAutoput,ppgRegionalniPut;
	scanf("%lf%lf%lf",&cenaGoriva,&ppgAutoput,&ppgRegionalniPut);
	scanf("%d%d",&n,&m);
	pret=(int *)malloc(n*sizeof(int ));
	pretPovratak=(int *)malloc(n*sizeof(int ));
	d=(int *)malloc(n*sizeof(int ));
	dPovratak=(int *)malloc(n*sizeof(int ));
	obidjen=(int *)malloc(n*sizeof(int ));
	obidjenPovratak=(int *)malloc(n*sizeof(int ));
	veze = (Veza **)malloc(n*sizeof(Veza *));
	for(i=0;i<n;i++)
	{
		veze[i] = (Veza *)malloc(n*sizeof(Veza));
	}
	for(i=0;i<n;i++)
	{
		obidjen[i]=0;
		obidjenPovratak[i]=0;
		pret[i]=-1;
		pretPovratak[i]=-1;
		d[i]=-1;
		dPovratak[i]=-1;
	}
	for(i=0;i<n;i++)
	for(j=0;j<n;j++)
	{
		veze[i][j].vred=-1;
	}
	for(i=0;i<m;i++)
	{
		scanf("%d%d%lf%d",&u,&v,&l,&autoput);
		veze[u][v].vred=1;
		veze[u][v].u=u;
		veze[u][v].v=v;
		veze[u][v].duzina = l;
		veze[u][v].autoput=autoput;
		if(autoput==1)
		{
			scanf("%lf",&putarina);
			veze[u][v].putarina=putarina;	
			veze[u][v].vred = l*ppgAutoput/100*cenaGoriva+putarina;		
		}else
		{
			veze[u][v].putarina=0;
			veze[u][v].vred = l*ppgRegionalniPut/100*cenaGoriva;
		}
	}
	scanf("%d%d",&polaziste,&odrediste);
	
	//printf("\n%d %d\n",polaziste,odrediste);
	d[polaziste]=0;
	dijkstra(veze,obidjen,d,pret,n);
	int suma=0;
	suma=skloniPoseceneGradove(veze,d,pret,n,odrediste,polaziste);
	dPovratak[odrediste]=0;
	dijkstra(veze,obidjenPovratak,dPovratak,pretPovratak,n);
	int r=0;
	r=rekonstrukcija(dPovratak,pretPovratak,n);
	if(r==-1) printf("\n-1\n");
	else
	{
		printf("CenaPuta: %d\n",(s+r));
		printf("KilometrazaPutovanja: %d\n",kilometraza);
	}
	int ind=0;
	
	return 0;
}
