#include <stdio.h>
#include <stdlib.h>

#define INF (-1)
#define NILL (-1)
#define FALSE 0
#define TRUE 1

int jeManji(double i,double j){
	if(i==INF)
		return FALSE;
	if(j==INF)
		return TRUE;
	return i<j;
}

int nadjiMinimum(int *obidjen,double *d,int n){
	int i;
	int minCvor=NILL;
	double min=INF;
	for(i=0;i<n;i++)
	{
		if(obidjen[i]==FALSE && jeManji(d[i],min)){
			min=d[i];
			minCvor=i;
		}
	}
	return minCvor;
}

void relax(double **graf,int *pret,double *d,int u,int v){
	if(jeManji(graf[u][v]+d[u],d[v])){
		d[v]=graf[u][v]+d[u];
		pret[v]=u;
	}
}

void dijkstra(double **graf,int *obidjen,int *pret,double *d,int n){
	int i,u,v;
	
	for(i=0;i<n;i++){
		u=nadjiMinimum(obidjen,d,n);
		obidjen[u]=TRUE;
		for(v=0;v<n;v++){
			if(obidjen[v]==FALSE && graf[u][v]!=INF){
				relax(graf,pret,d,u,v);
			}
		}
	}
}
int niz[50];
int br=0;
void putP(int *pret,int u,int v){
	if(u==v){
		printf("%d ",v);
		niz[br]=v;
		br++;
		return;
	}
	else{
		putP(pret,u,pret[v]);
		printf("%d ",v);
		niz[br]=v;
		br++;
	}
}






int main()
{
	double **graf;
	double *d;
	int *obidjen,*pret;
	int i,j,n,m,u,v,t;
	double l,p,potrosnjaA,potrosnjaR,cenaG;
	double **duzine;
	scanf("%lf%lf%lf",&cenaG,&potrosnjaA,&potrosnjaR);
	scanf("%d%d",&n,&m);
	
	
	graf=(double **)malloc(sizeof(double *)*n);
	duzine=(double **)malloc(sizeof(double *)*n);
	d=(double *)malloc(sizeof(double)*n);
	pret=(int *)malloc(sizeof(int)*n);
	obidjen=(int *)malloc(sizeof(int)*n);
	
	
	for(i=0;i<n;i++){
		graf[i]=(double *)malloc(sizeof(double)*n);
		duzine[i]=(double *)malloc(sizeof(double)*n);
		d[i]=INF;
		pret[i]=NILL;
		obidjen[i]=FALSE;
	}
	for(i=0;i<n;i++)
	for(j=0;j<n;j++){
		graf[i][j]=INF;
		duzine[i][j]=INF;
	}
		
	for(i=0;i<m;i++){
		scanf("%d%d%lf%d",&u,&v,&l,&t);
		if(t==1){
			scanf("%lf",&p);
			if(graf[u][v]!=INF){
				if(jeManji((l*(potrosnjaA/100))*cenaG+p,graf[u][v])){
					graf[u][v]=(l*(potrosnjaA/100))*cenaG+p;
					graf[v][u]=(l*(potrosnjaA/100))*cenaG+p;
					duzine[u][v]=duzine[v][u]=l;
				}
			}
			else{
				graf[u][v]=(l*(potrosnjaA/100))*cenaG+p;
				graf[v][u]=(l*(potrosnjaA/100))*cenaG+p;
				duzine[u][v]=duzine[v][u]=l;
			}
		}
		else{
			if(graf[u][v]!=INF){
				if(jeManji((l*(potrosnjaR/100))*cenaG,graf[u][v])){
					graf[u][v]=(l*(potrosnjaR/100))*cenaG;
					graf[v][u]=(l*(potrosnjaR/100))*cenaG;
					duzine[u][v]=duzine[v][u]=l;
				}
			}
			else{
				graf[u][v]=(l*(potrosnjaR/100))*cenaG;
				graf[v][u]=(l*(potrosnjaR/100))*cenaG;
				duzine[u][v]=duzine[v][u]=l;
			}
		}
	}
	int polaziste,odrediste;
	scanf("%d%d",&polaziste,&odrediste);
	d[polaziste]=0;
	dijkstra(graf,obidjen,pret,d,n);
	int pom1=polaziste,pom2=odrediste;
	double ukupnoC=0,ukupnoD=0;
	while(pom1!=pom2){
		ukupnoC+=graf[pom2][pret[pom2]];
		ukupnoD+=duzine[pom2][pret[pom2]];
		pom2=pret[pom2];
	}
	
	putP(pret,polaziste,odrediste);
	
	for(i=0;i<n;i++){
		d[i]=INF;
		pret[i]=NILL;
		obidjen[i]=FALSE;
	}
	for(i=0;i<br-1;i++){
		niz[i]=niz[i+1];
			
	}
	br=br-2;
	
	for(j=0;j<br;j++){
	for(i=0;i<n;i++){
		graf[niz[j]][i]=INF;
		graf[i][niz[j]]=INF;
		duzine[niz[j]][i]=INF;
		duzine[i][niz[j]]=INF;
	}}
	d[odrediste]=0;
	for(i=0;i<br;i++){
		obidjen[niz[i]]=TRUE;	
	}
	dijkstra(graf,obidjen,pret,d,n);
	pom2=polaziste,pom1=odrediste;
	while(pom1!=pom2){
		ukupnoC+=graf[pom2][pret[pom2]];
		ukupnoD+=duzine[pom2][pret[pom2]];
		pom2=pret[pom2];
			}
	putP(pret,odrediste,polaziste);
	printf("\n%lf\n%lf\n",ukupnoC,ukupnoD);
}





























