#include <stdio.h>
#include <stdlib.h>
#define TRUE 1
#define FALSE 0
#define INF (-1)
#define NILL (-1)

int jeManji(double i, double j)
{
	if(i==-1)
		return FALSE;
	else if(j==-1)
		return TRUE;
		
	return i<j;
}
double ukupnaKilometraza = 0.0;
	
int dajNajbolji(double *d, int *obidjen, int n)
{
	double min=-1.0;
	int minCvor=-1, i;
	
	for(i=0; i<n; i++)
	{
		if(obidjen[i] == FALSE && jeManji(d[i], min))
		{
			min=d[i];
			minCvor=i;
		}
	}
	return minCvor;
}
void relaks(int u, int v, double **graf, int n, double *d, int *pret)
{
	if(jeManji(d[u]+ graf[u][v], d[v]))
	{
		d[v] = d[u] + graf[u][v];
		pret[v]=u;
		
	}
}
void dijkstra(double **graf, int *obidjen,double *d, int *pret, int n)
{
	int u, v;
	while((u = dajNajbolji(d, obidjen, n)) !=-1)
	{
		obidjen[u] = TRUE;
		
		for(v=0; v<n; v++)
		{
			if(obidjen[v] == FALSE && graf[u][v] != -1)
			{
				relaks(u, v, graf, n, d, pret);
			}
		}
	}
}
void rek(int *pret, double **graf, int trenutni)
{
	if(pret[trenutni] == -1) 
	{
		printf("%d ", trenutni);
		return;
	}
	else
	{
	
		printf("%d ", trenutni);
		rek(pret, graf, pret[trenutni]);
	}
}


void duz(int *pret, double **graf, int trenutni, double *duzina)
{
	if(pret[trenutni] == -1) 
	{
		ukupnaKilometraza+=duzina[trenutni];
		return;
	}
	else
	{
		ukupnaKilometraza+=duzina[trenutni];
		duz(pret, graf, pret[trenutni],duzina);
	}
}


int main()
{
	int n, m;

	double cenaGoriva;
	scanf("%lf", &cenaGoriva);
	
	double potrosnjaGorivaA, potrosnjaGorivaR;
	scanf("%lf%lf", &potrosnjaGorivaA, &potrosnjaGorivaR);	
	scanf("%d%d", &n, &m);

	int *obidjen, *pret;
	double *d;

	obidjen = (int*)malloc(n * sizeof(int));
	d = (double*)malloc(n* sizeof(double));
	pret=(int*)malloc(n* sizeof(int));
	double **graf;
	graf = (double**)malloc(n*sizeof(double*));
	
	int u, v, i, j,tipPuta;
	double l, putarina;

	for(i=0; i<n; i++)
	{
		graf[i]=(double*)malloc(n *sizeof(double));
		for(j = 0; j<n; j++)
		{
			graf[i][j] = -1.0;
		}
		
		obidjen[i] = FALSE;
		d[i] = -1;
		pret[i] = NILL;
	}
	
	
	double duzinePuta[n];
	//1 autoput, 0 nije
	for(i=0; i<m; i++)
	{
		putarina = 0.0;
		
		scanf("%d%d%lf%d", &u, &v, &l, &tipPuta);
		if(tipPuta==1)
			scanf("%lf", &putarina);
		
		duzinePuta[i] = l;
		
		
		double w;
		if(tipPuta==1)
			w = putarina + potrosnjaGorivaA/100 * cenaGoriva * l;
		else
			w = potrosnjaGorivaR/100 * l *cenaGoriva;
		
		graf[u][v] = w;
		graf[v][u] = w;
	}
	/*for(i=0; i<n; i++)
	{
		for(j=0; j<n; j++)
		{
			printf("%d - %d = %lf ", i, j, graf[i][j]);
		}
		printf("\n");
	}
	printf("\n"); */

	double cenaPutovanja = 0.0;
	int polaziste, odrediste;
	scanf("%d%d", &polaziste, &odrediste);
	
	d[polaziste] = 0.0;	
	dijkstra(graf, obidjen, d, pret, n);
	cenaPutovanja+=d[odrediste];

	for(i=0; i<n; i++)
	{
		d[i] = -1;
		obidjen[i] = FALSE;
		pret[i] = NILL;
	}
	duz(pret, graf, odrediste, duzinePuta);
	
	
	d[odrediste] =0;
	dijkstra(graf, obidjen, d, pret, n);
	
	cenaPutovanja+=d[polaziste];
	printf("%.4lf\n", cenaPutovanja);
	
	printf("%.4lf\n", ukupnaKilometraza);
	
	rek(pret, graf, odrediste);
	
	duz(pret, graf, polaziste, duzinePuta);
	rek(pret, graf, polaziste);
	
}
