#include <stdio.h>
#include <stdlib.h>

#define INF (-1)
#define NILL (-1)
#define TRUE 1
#define FALSE 0

typedef struct {
	int indikator_r_a;
	float duzina;
	float totalCena;
} Graf;

int jeManji(int i, int j)
{
	if(i == INF)
		return FALSE;
	if(j == INF)
		return TRUE;
	return i<j;
}

int nadjiMinimum(int *obidjen, float *d, int n)
{
	int i;
	int min = INF, minCvor = NILL;
	for(i=0; i<n; i++)
	{
		if(obidjen[i] == FALSE && jeManji(d[i], min))
		{
			min = d[i];
			minCvor = i;
		}
	}
	return minCvor;
}

void relax(Graf **graf, float *d, int *pret, int u, int v)
{
	if(jeManji(d[u] + graf[u][v].totalCena, d[v]))
	{
		d[v] = d[u] + graf[u][v].totalCena;
		pret[v] = u;
	}
}

void dijkstra(Graf **graf, int *obidjen, float *d, int *pret, int n)
{
	int i, u, v;
	for(i=0; i<n; i++)
	{
		u = nadjiMinimum(obidjen, d, n);
		obidjen[u] = TRUE;
		for(v=0; v<n; v++)
		{
			if(graf[u][v].totalCena != INF && obidjen[v] == FALSE)
			{
				relax(graf, d, pret, u, v);
			}
		}
	}
}

int nadjiMinimum1(int *obidjen, float *d, int n)
{
	int i;
	int min = INF, minCvor = NILL;
	for(i=0; i<n; i++)
	{
		if(obidjen[i] == FALSE && jeManji(d[i], min))
		{
			min = d[i];
			minCvor = i;
		}
	}
	return minCvor;
}

void relax1(Graf **graf, float *d, int *pret, int u, int v)
{
	if(jeManji(d[u] + graf[u][v].duzina, d[v]))
	{
		d[v] = d[u] + graf[u][v].duzina;
		pret[v] = u;
	}
}

void dijkstra1(Graf **graf, int *obidjen, float *d, int *pret, int n)
{
	int i, u, v;
	for(i=0; i<n; i++)
	{
		u = nadjiMinimum1(obidjen, d, n);
		obidjen[u] = TRUE;
		for(v=0; v<n; v++)
		{
			if(graf[u][v].duzina != INF && obidjen[v] == FALSE)
			{
				relax1(graf, d, pret, u, v);
			}
		}
	}
}

void stampajPutanju(int *pret, int a, int b)
{
	if(pret[b] == a)
	{
		printf("%d ", a);
		return;
	}
	else
	{
		stampajPutanju(pret, a, pret[b]);
		printf("%d ", b);
		return;
	}
}

void ukloniPredjeneGradove(Graf **graf, int *obidjen, float *d, int *pret, int n, int a, int b)
{
	if(pret[b] == a)
	{
		return;
	}
	else
	{
		ukloniPredjeneGradove(graf, obidjen, d, pret, n, a, pret[b]);
		for(i=0; i<n; i++)
		{
			for(j=0; j<n; j++)
			{
				if(i == b && j == pret[b])
				{
					graf[i][j].totalCena = graf[i][j].totalCena * 300;
				}
			}
		}
	}
}

void ukloniPredjeneGradove1(Graf **graf, int *obidjen, float *d, int *pret, int n, int a, int b)
{
	if(pret[b] == a)
	{
		return;
	}
	else
	{
		ukloniPredjeneGradove(graf, obidjen, d, pret, n, a, pret[b]);
		for(i=0; i<n; i++)
		{
			for(j=0; j<n; j++)
			{
				if(i == b && j == pret[b])
				{
					graf[i][j].totalCena = graf[i][j].duzina * 300;
				}
			}
		}
	}
}

int main()
{
	Graf **graf;
	float *d, 
	int *pret, *obidjen;
	int n, m;
	int i, j;
	int u, v;
	float w;
	float ukupno;
	int ind_r_a;
	float cenaGoriva;
	float regionalniPotrosnja, autoputPotrosnja;
	float putarina;
	int a, b;
	int kmPotrosnja;
	//printf("Unesi broj cvorova i veza:\n");
	scanf("%d%d", &n, &m);

	graf = (Graf **)malloc(n*sizeof(Graf *));
	dA = (float *)malloc(n*sizeof(float));
	pretA = (int *)malloc(n*sizeof(int));
	obidjenA = (int *)malloc(n*sizeof(int));

	dB = (float *)malloc(n*sizeof(float));
	pretB = (int *)malloc(n*sizeof(int));
	obidjenB = (int *)malloc(n*sizeof(int));

	for(i=0; i<n; i++)
	{
		graf[i] = (Graf *)malloc(n*sizeof(Graf));
		dA[i] = INF;
		pretA[i] = NILL;
		obidjenA[i] = FALSE;
		dB[i] = INF;
		pretB[i] = NILL;
		obidjenB[i] = FALSE;
	}

	for(i=0; i<n; i++)
		for(j=0; j<n; j++)
			graf[i][j].totalCena = INF;

	//printf("Unesi cenu goriva:\n");
	scanf("%f", &cenaGoriva);

	//printf("Unesi potrosnju na regionalnom putu i autoputu:\n");
	scanf("%f%f", &regionalniPotrosnja, &autoputPotrosnja);

	for(i=0; i<m; i++)
	{
		//printf("start, end, duzina, ind_r_a:\n"); 
		scanf("%d%d%f%d", &u, &v, &w, &ind_r_a);

		if(ind_r_a == 1)
		{
			//printf("Unesi putarinu:\n");
			scanf("%f", &putarina);
			kmPotrosnja = autoputPotrosnja / 100;
			ukupno = w * kmPotrosnja * cenaGoriva;
			ukupno = ukupno + putarina;
		}
		else
		{
			kmPotrosnja = regionalniPotrosnja / 100;
			ukupno = w * kmPotrosnja * cenaGoriva;
		}

		if(graf[u][v].totalCena != INF)
		{
			if(graf[u][v].totalCena > ukupno)
			{
				graf[u][v].totalCena = ukupno;
				graf[v][u].totalCena = ukupno;
				graf[u][v].duzina = w;
				graf[u][v].duzina = w;
				if(ind_r_a == 1)
				{
					graf[u][v].indikator_r_a = 1;
					graf[u][v].indikator_r_a = 1;
				}
				else
				{
					graf[u][v].indikator_r_a = 0;
					graf[u][v].indikator_r_a = 0;
				}
			}
		}
		else
		{
			graf[u][v].totalCena = ukupno;
			graf[v][u].totalCena = ukupno;
			graf[u][v].duzina = w;
			graf[u][v].duzina = w;
			if(ind_r_a == 1)
			{
				graf[u][v].indikator_r_a = 1;
				graf[u][v].indikator_r_a = 1;
			}
			else
			{
				graf[u][v].indikator_r_a = 0;
				graf[u][v].indikator_r_a = 0;
			}
		}
	}

	//printf("Unesi polaziste:\n"); scanf("%d", &a);
	dA[a] = 0;

	//printf("Unesi odrediste:\n"); scanf("%d", &b);
	dB[b] = 0;


	dijkstra(graf, obidjenA, dA, pretA, n);

	ukloniPredjeneGradove(graf, obidjenA, dA, pretA, n, a, b);

	dijkstra(graf, obidjenB, dB, pretB, n);


	//printf("Cena putovanja:\n");
	printf("%.4f\n", dA[b] + dB[a]);

	for(i=0; i<n; i++)
	{
		dA[i] = INF;
		pretA[i] = NILL;
		obidjenA[i] = FALSE;
		dB[i] = INF;
		pretB[i] = NILL;
		obidjenB[i] = FALSE;
	}

	dijkstra1(graf, obidjenA, dA, pretA, n);

	ukloniPredjeneGradove1(graf, obidjenA, dA, pretA, n, a, b);

	dijkstra1(graf, obidjenB, dB, pretB, n);

	//printf("Kilometraza putovanja:\n");
	printf("%.4f\n", dA[b] + dB[a]);

	//printf("polaziste - odrediste:\n");
	stampajPutanju(pretA, a, b);

	//printf("odrediste - polaziste:\n");
	stampajPutanju(pretB, a, b);
	//printf("\n");

	return 0;
}