#include <stdio.h>
#include <stdlib.h> 

#define SKUP_B 1
#define SKUP_N 0

double **a, *x, *c, *b;
int m, n,*bn;
double v;

void ucitaj()
{
	int i,j;
	m = 5;
	n = 4;
	
	a = (double **)malloc((n+m)*sizeof(double *));
	x = (double *)malloc((n+m)*sizeof(double));
	b = (double *)malloc((n+m)*sizeof(double));
	c = (double *)malloc((n+m)*sizeof(double));
	bn = (int *)malloc((n+m)*sizeof(int));
	
	for(i = 0; i < m+n; i++)
	{
		a[i] = (double *)malloc((n+m)*sizeof(double));
		c[i] = 0.0;
		b[i] = 0.0;
		
		if(i < n)
			bn[i] = SKUP_N;
		else 
			bn[i] = SKUP_B;
			
		for(j = 0; j < m+n; j++)
			a[i][j] = 0.0;
	}
	
	double sljiva,kajsija,visnja,secer;
	// dzem 1
	scanf("%lf%lf%lf%lf",&sljiva,&kajsija,&visnja,&secer);
	a[n][0] = secer;
	a[n+1][0] = sljiva;
	a[n+2][0] = kajsija;
	a[n+3][0] = visnja;
	
	// dzem 2
	scanf("%lf%lf%lf",&sljiva,&kajsija,&secer);
	a[n][1] = secer;
	a[n+1][1] = sljiva;
	a[n+2][1] = kajsija;
	
	// dzem 3
	scanf("%lf%lf%lf",&sljiva,&visnja,&secer);
	a[n][2] = secer;
	a[n+1][2] = sljiva;
	a[n+3][2] = visnja;
	
	// dzem 4
	scanf("%lf%lf%lf",&kajsija,&visnja,&secer);
	a[n][3] = secer;
	a[n+2][3] = kajsija;
	a[n+3][3] = visnja;
	
	for(i = n; i < m+n-1; i++)
		scanf("%lf",&b[i]);
	
	for(i = 0; i < n; i++)
		scanf("%lf",&c[i]);
	
	scanf("%lf",&b[n+m-1]);
	scanf("%lf",&a[n+m-1][0]);
	c[0] -= a[n+m-1][0];
	scanf("%lf",&a[n+m-1][1]);
	c[1] -= a[n+m-1][1];
	scanf("%lf",&a[n+m-1][2]);
	c[2] -= a[n+m-1][2];
	scanf("%lf",&a[n+m-1][3]);
	c[3] -= a[n+m-1][3];
	
	
	v = 0.0;
}

void stampaj()
{
	int i, j;
	printf("\nA:\n");
	for(i = 0; i < m+n; i++)
	{
		for(j = 0; j < m+n; j++)
			printf("%.2lf ",a[i][j]);
		printf("\n");
	}
	
	printf("\nB:\n");
	for(i = 0; i < m+n; i++)
		printf("%.2lf ",b[i]);
		
	printf("\nC:\n");
	for(i = 0; i < m+n; i++)
		printf("%.2lf ",c[i]);
	
	printf("\nBN:\n");
	for(i = 0; i < m+n; i++)
		printf("%d ",bn[i]);
	printf("\n");
}

int nadjiUlaz()
{
	int i;
	int e = -1;
	for(i = 0; i < m+n; i++)
		if(bn[i] == SKUP_N && c[i] > 0)
		{
			e = i;
			break;
		}
	return e;
}

int nadjiIzlaz(int e)
{
	int i, l = -1;
	double min = -1.0;
	
	for(i = 0; i < m+n; i++)
		if(bn[i] == SKUP_B && a[i][e] > 0)
		{
			if(min == -1.0 || b[i]/a[i][e] < min)
			{
				min = b[i]/a[i][e];
				l = i;
			}
		}
	
	return l;
}

void pivot(int e, int l)
{
	int i,j;
	b[e] = b[l]/a[l][e];
	
	for(j = 0; j < m+n; j++)
		if(bn[j] == SKUP_N && j != e)
			a[e][j] = a[l][j]/a[l][e];
			
	a[e][l] = 1/a[l][e];
	for(i = 0; i < m+n; i++)
		if(bn[i] == SKUP_B && i != l)
		{
			b[i] = b[i] - b[e]*a[i][e];
			for(j = 0; j < m+n; j++)
				if(bn[j] == SKUP_N && j != e)
					a[i][j] = a[i][j] - a[i][e]*a[e][j];
			a[i][l] = -a[i][e]*a[e][l];
		}
		
	v = v + c[e]*b[e];
	for(j = 0; j < m+n; j++)
		if(bn[j] == SKUP_N && j != e)
			c[j] = c[j] - c[e]*a[e][j];
	c[l] = -c[e]*a[e][l];
	
	bn[e] = SKUP_B;
	bn[l] = SKUP_N;
}

int main()
{
	int e, l;
	int i;
	
	ucitaj();
	//stampaj();
	
	
	while((e = nadjiUlaz()) != -1)
	{
		l = nadjiIzlaz(e);
		if(l == -1)
		{
			printf("Neogranicen problem.\n");
			break;
		}
		else
			pivot(e,l);
	}
	
	//stampaj();
	
	if(e == -1)
	{
		printf("%.2lf\n",v);
		for(i = 0; i < n; i++)
		{
			if(bn[i] == SKUP_B)
				x[i] = b[i];
			else
				x[i] = 0.0;
				
			printf("%.2lf ",x[i]);
		}
		printf("\n");
	}
	
	return 0;
}
