#include <stdio.h>
#include <stdlib.h>

#define NEDEFINISANO -1
#define FALSE 0
#define TRUE 1

#define AUTOPUT 1
#define REGIONALNI 0

float cenaUkupno = 0;
float kilometriUkupno = 0;
int *niz;
int br;

// DIJKSTRA

typedef struct element
{
	int tipPuta;
	float cena;
	float kilometraza;
}element;

int manji(float a, float b)
{
	if(a == NEDEFINISANO)
		return 0;
	if(b == NEDEFINISANO)
		return 1;
		
	return a < b;
}

int nadjiMinimum(int *obidjen, float *d, int n)
{
	int i;
	float min = -1;
	int minCvor = -1;
	
	for(i = 0; i < n; i++)
	{
		if(obidjen[i] != NEDEFINISANO && manji(d[i],min))
		{
			min = d[i];
			minCvor = i;
		}
	}
	
	return minCvor;
}

void relax(element **graf,float *d, float *p,int u,int v)
{
	if(manji(d[u]+graf[u][v].cena,d[v]))
	{
		d[v] = d[u]+graf[u][v].cena;
		p[v] = u;
	}
}

void rekonstrukcija(float *d, float *p, int u, int v,element **graf)
{
	if(u == v)
	{
		niz[br++] = v;
		//printf(" %d ",v);
		kilometriUkupno += graf[u][v].kilometraza;
		
	}
	else
	{
		rekonstrukcija(d,p,u,p[v],graf);
		//printf(" %d ",u);
		niz[br++] = u;
		cenaUkupno += graf[u][v].cena;
	}
}

int main()
{
	element **graf;
	float *dOdlazak, *pOdlazak;
	int *obidjenOdlazak;
	int m,n,i,j,u,v;
	float cenaGoriva;
	float potrosnjaAutoput, potrosnjaRegionalni;
	scanf("%f",&cenaGoriva); //1l na 100km
	scanf("%f%f",&potrosnjaAutoput,&potrosnjaRegionalni);
	
	scanf("%d%d",&n,&m);
	// broj gradova i veza
	
	graf = (element **)malloc(n*sizeof(element *));
	dOdlazak = (float *)malloc(n*sizeof(float));
	pOdlazak = (float *)malloc(n*sizeof(float));
	obidjenOdlazak = (int *)malloc(n*sizeof(int));
	
	for(i = 0; i < n; i++)
	{
		graf[i] = (element *)malloc(n*sizeof(element));
		dOdlazak[i] = NEDEFINISANO;
		pOdlazak[i] = NEDEFINISANO;
		obidjenOdlazak[i] = FALSE;
		for(j = 0; j < n; j++)
		{
			graf[i][j].tipPuta = NEDEFINISANO;
			graf[i][j].cena = NEDEFINISANO;
			graf[i][j].kilometraza = NEDEFINISANO;
		}
	}
	
	float udaljenost, putarina;
	int tip;
	float cc;
	for(i = 0; i < m; i++)
	{
		scanf("%d%d",&u,&v);
		scanf("%f%d",&udaljenost,&tip);
		
		cc = 0;
		if(graf[u][v].kilometraza != NEDEFINISANO)
		{
			// ako za cvor vec postoje parametri
			if(tip == REGIONALNI && graf[u][v].tipPuta == REGIONALNI)
			{
				if(udaljenost < graf[u][v].kilometraza)
				{
					cc = cenaGoriva*(udaljenost/100);
					cc *= potrosnjaRegionalni;
					graf[u][v].cena = graf[v][u].cena = cc;
					graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
					graf[u][v].tipPuta = graf[v][u].tipPuta = REGIONALNI;
				}
			}
			else if(tip == AUTOPUT && graf[u][v].tipPuta == AUTOPUT)
			{
				if(udaljenost < graf[u][v].kilometraza)
				{
					scanf("%f",&putarina);
					cc = cenaGoriva*(udaljenost/100);
					cc *= potrosnjaAutoput;
					cc += putarina;
					
					graf[u][v].cena = graf[v][u].cena = cc;
					graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
					graf[u][v].tipPuta = graf[v][u].tipPuta = AUTOPUT;
				}
				else scanf("%f",&putarina);
			}
			else {
				// Ako treba da biramo izmedju autoputa i regionalnog
				// cija cena bude manja taj cu izabrati
				if(tip == REGIONALNI)
				{
					cc = cenaGoriva*(udaljenost/100);
					cc *= potrosnjaRegionalni;
					if(graf[u][v].cena > cc)
					{
						graf[u][v].cena = graf[v][u].cena = cc;
						graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
						graf[u][v].tipPuta = graf[v][u].tipPuta = REGIONALNI;
					}
				}
				else 
				{
					scanf("%f",&putarina);
					cc = cenaGoriva*(udaljenost/100);
					cc *= potrosnjaAutoput;
					cc += putarina;
					if(graf[u][v].cena > cc)
					{
						graf[u][v].cena = graf[v][u].cena = cc;
						graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
						graf[u][v].tipPuta = graf[v][u].tipPuta = AUTOPUT;
					}
				}
			}
		}
		else
		{
			// Ako je za cvor nedefinisano, -1
			if(tip == REGIONALNI)
			{
				cc = cenaGoriva*(udaljenost/100);
				cc *= potrosnjaRegionalni;
				graf[u][v].cena = graf[v][u].cena = cc;
				graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
				graf[u][v].tipPuta = graf[v][u].tipPuta = REGIONALNI;
			}
			else 
			{
				scanf("%f",&putarina);
				cc = cenaGoriva*(udaljenost/100);
				cc *= potrosnjaAutoput;
				cc += putarina;
				
				graf[u][v].cena = graf[v][u].cena = cc;
				graf[u][v].kilometraza = graf[v][u].kilometraza = udaljenost;
				graf[u][v].tipPuta = graf[v][u].tipPuta = AUTOPUT;
			}
		}
	}
	
	int polaziste, odrediste;
	scanf("%d%d",&polaziste,&odrediste);
	/*
	for(i = 0; i < n; i++)
	{
		for(j = 0; j < n; j++)
			printf("%.2f  ",graf[i][j].kilometraza);
		printf("\n");
	}
	*/
	// matrica dobro rasporedjena, rucno kada saberem ispada kako treba
	
	dOdlazak[polaziste] = 0;
	while((u = nadjiMinimum(obidjenOdlazak,dOdlazak,n)) != NEDEFINISANO)
	{
		//printf("U %d\n",u);
		obidjenOdlazak[u] = TRUE;
		for(v = 0; v < n; v++)
			if(graf[u][v].cena != NEDEFINISANO && obidjenOdlazak[v] == FALSE)
				relax(graf,dOdlazak,pOdlazak,u,v);
	}
	// ovde upada u beskonacnu...
	
	/*
	for(i = 0; i < n; i++)
		printf("%.2f  ",dOdlazak[i]);
	*/
	
	br = 0;
	niz = (int *)malloc(n*sizeof(int));
	rekonstrukcija(dOdlazak,pOdlazak,polaziste,odrediste,graf);
	// i ovim smo dobili od polazista do odredista
	
	// sada nam treba od odlazista do polazista, ali ne sme da prodje kroz gradove 
	// kroz koje je vec prosla
	// tako da treba da postavimo kilometrazu i cenu na -1 za te gradove i opet uraditi dijkstru	
	
	int k;
	for(i = 0; i < br; i++)
	{
		if(niz[i] != polaziste && niz[i] != odrediste)
		{
			for(k = 0; k < n; k++)
				for(j = 0; j < n; j++)
					if(k == niz[i] || j == niz[i])
					{
						graf[k][j].cena = -1;
						graf[k][j].kilometraza = -1;
					}
		}
	}
	
	float *dPovratak, *pPovratak;
	int *obidjenPovratak;
	
	dPovratak = (float *)malloc(n*sizeof(float));
	pPovratak = (float *)malloc(n*sizeof(float));
	obidjenPovratak = (int *)malloc(n*sizeof(int));
	for(i = 0; i < n; i++)
	{
		dPovratak[i] = NEDEFINISANO;
		pPovratak[i] = NEDEFINISANO;
		obidjenPovratak[i] = FALSE;
	}
	
	dPovratak[odrediste] = 0;
	while((u = nadjiMinimum(obidjenPovratak,dPovratak,n)) != NEDEFINISANO)
	{
		//printf("U %d\n",u);
		obidjenPovratak[u] = TRUE;
		for(v = 0; v < n; v++)
			if(graf[u][v].cena != NEDEFINISANO && obidjenPovratak[v] == FALSE)
				relax(graf,dPovratak,pPovratak,u,v);
	}
	
	rekonstrukcija(dPovratak,pPovratak,pPovratak[odrediste],polaziste,graf);
	printf("%.4f\n",cenaUkupno);
	printf("%.4f\n",kilometriUkupno);
	for(i = 0; i < br; i++)
		printf("%d ",niz[i]);
	
	printf("\n");
	return 0;
}
