#include<stdio.h>
#include<stdlib.h>

#define NILL -1
#define INF -1
#define TRUE 1
#define FALSE 0
#define AUTOPUT 1
#define REG 0

int minimum(int i, int j){
	if(i==INF)
	return FALSE;
	if(j==INF)
	return TRUE;
	return i<j;
}

/*typedef struct{
	int u;
	int v;
	double w;
}Veza;*/

int nadjiMin(double **graf, int *obidjen, double *d, int *pret, int *normalan, int n){
	int i;
	int min = INF, minCvor = NILL;
	
	for(i=0; i<n; i++){
		if(obidjen[i] ==FALSE && normalan[i] == TRUE && minimum(d[i],min)){
			min = d[i];
			minCvor = i;
		}
	}
	return minCvor;
	
}

void relax(int u, int v, double **graf, double *d, int *pret, int n){
	if(minimum(graf[u][v] + d[u], d[v])){
		d[v] = graf[u][v] + d[u];
		pret[v] = u;
	}
}

void dijkstra(double **graf, int *obidjen, double *d, int *pret, int *normalan, int n){
	int u,v;
	int i;
	for(i=0; i<n; i++){
		u = nadjiMin(graf, obidjen, d, pret, normalan, n);
		obidjen[u] = TRUE;
		for(v=0; v<n; v++){
			if(graf[u][v]!=INF && normalan[v] == TRUE && obidjen[v]==FALSE){
				relax(u, v, graf, d, pret, n);
			}
		}
	}
}
void rekonstrukcija(int i, int polaziste, int *pret, double *d, int n){
	if(i==polaziste){
		printf("%d ",i);
		return;
	}
	
	rekonstrukcija(pret[i], polaziste, pret, d, n);
	printf("%d ",i);
	
}

int main(){
	
	double **graf;
	double *d;
	int *obidjen;
	int *pret;
	int *normalan;
	int n,m;
	int i,j;
	int u,v;
	double l;
	double cenaGoriva, potrosnjaGoriva_auto, potrosnjaGoriva_reg;
	double putarina;
	int polaziste, odrediste;
	//int brojUvrstenihVeza=0;
//	Veza *veze;
//	int *zauzetost;
	
	scanf("%lf",&cenaGoriva);
	cenaGoriva = cenaGoriva / 100;
	scanf("%lf%lf",&potrosnjaGoriva_auto, &potrosnjaGoriva_reg);
	
	scanf("%d%d",&n, &m);
	
	graf = (double**)malloc(n*sizeof(double*));
	d = (double*)malloc(n*sizeof(double));
	obidjen = (int*)malloc(n*sizeof(int));
	pret = (int*)malloc(n*sizeof(int));
	normalan = (int*)malloc(n*sizeof(int));
	/*veze = (Veza*)malloc(m*sizeof(Veza));
	zauzetost = (int*)malloc(n*sizeof(int));*/
	
	for(i=0; i<n; i++){
		graf[i] = (double*)malloc(n*sizeof(double));
		//pret[i] = (double*)malloc(n*sizeof(double));
		obidjen[i] = FALSE;
		d[i] = INF;
		pret[i] = NILL;
		normalan[i] = TRUE;
		//zauzetost[i] = i;
	}
	
	for(i=0; i<n; i++){
		for(j=0; j<n; j++){
			graf[i][j] = INF;
			//pret[i][j] = NILL;
		}
	}
	
	int pom;
	
	for(i=0; i<m; i++){
		scanf("%d%d%lf%d",&u, &v, &l, &pom);
		putarina = 0;
		
		graf[u][v] = l * potrosnjaGoriva_reg * cenaGoriva + putarina;
		graf[v][u] = l * potrosnjaGoriva_reg * cenaGoriva + putarina;
		
		if(pom == AUTOPUT){
			scanf("%lf", &putarina);
			graf[u][v] = l * potrosnjaGoriva_auto * cenaGoriva + putarina;
			graf[v][u] = l * potrosnjaGoriva_auto * cenaGoriva + putarina;
		}
	}
	
	//Veza pom;
	
	/*for(i=0; i<m-1; i++){
		for(j=i+1; j<m; j++){
			if(veza[i].w > veza[j].w){
				pom = veza[i];
				veza[i] = veza[j];
				veza[j] = pom;
			}
		}
	}*/
	
	scanf("%d%d",&polaziste, &odrediste);
	
	d[polaziste] = 0;
	
	/*for(i=0; i<n; i++){
		printf("%d %d %lf %d\n",obidjen[i], pret[i], d[i], normalan[i]);
	}
	
	for(i=0; i<n; i++){
		for(j=0; j<n; j++){
			printf("%lf ",graf[i][j]);
		}
		printf("\n");
	}*/
	
	dijkstra(graf, obidjen, d, pret, normalan, n);
	//double rbr;
	rekonstrukcija(odrediste, polaziste, pret, d, n);
	printf("\n");
	
	int niz[50];
	
	i = odrediste;
	int k=0;
	while(i!=polaziste){
		if(pret[i]!=polaziste){
			niz[k++] = pret[i];
		}
		i = pret[i];
	}
	
	for(i=0; i<n; i++){
		obidjen[i] = FALSE;
		pret[i] = NILL;
		d[i] = INF;
		for(j=0; j<k; j++){
			if(niz[j] == i){
				normalan[i] = FALSE;
				break;
			}
		}
	}
	
	/*for(i=0; i<k; i++){
		printf("%d ",niz[i]);
	}
	printf("\n");*/
	
	
	
	d[odrediste] = 0;
	
	/*for(i=0; i<n; i++){
		printf("%d %d %lf %d\n",obidjen[i], pret[i], d[i], normalan[i]);
	}
	
	for(i=0; i<n; i++){
		for(j=0; j<n; j++){
			printf("%lf ",graf[i][j]);
		}
		printf("\n");
	}*/
	
	printf("%d \n",nadjiMin(graf,obidjen,d,pret,normalan,n));
	//dijkstra(graf, obidjen, d, pret, normalan, n);
	
	//rekonstrukcija(polaziste, odrediste, pret, d, n);
	
	
	
	
	
	
	return 0;
}












