#include<stdio.h>
#include<stdlib.h>

#define INF -1
#define NILL -1

#define TRUE 1
#define FALSE 0

int jeManji(double a, double b)
{
    if(a < 0)
        return FALSE;
    if(b < 0)
        return TRUE;
    
    return a < b;
}

int nadjiNajmanji(int *obidjeni, int *prosla, double *d, int n)
{
    int minCvor, i;
    double min = INF;

    for(i = 0; i < n; i++)
    {
        if(obidjeni[i] == FALSE && prosla[i] == FALSE && jeManji(d[i], min))
        {
            min = d[i];
            minCvor = i;
        }
    }

    return minCvor;
}

void relax(double **graf, double *d, int *pret, int u, int v)
{
        if(jeManji(d[u] + graf[u][v], d[v]))
        {
            d[v] = graf[u][v] + d[u];
            pret[v] = u;
        }
}

void dijkstra(double **graf, double *d, int *obidjeni, int *pret, int n, int br, int *prosla)
{
    int i, u, v;

    for(i = 0; i < br; i++)
    {
        u = nadjiNajmanji(obidjeni, prosla, d, n);
        obidjeni[u] = TRUE;

        //printf("u->%d\n", u);

        for(v = 0; v < n; v++)
        {
            //printf("v-->%d\n", v);
            if(graf[u][v] > 0)
            {
                relax(graf, d, pret, u, v);
            }
            //printf("v-->%d\n", v);
        }
    }
}

void stampajPut(int *pret, int s, int v, int *prosla, int *br, int f,int *glavnaPutanja, int *q)
{
    if(s == v)
    {
        if(f == 0)
        {
            //printf("%d ", s);
            glavnaPutanja[*q] = s;
            (*q)++;
            prosla[s] = TRUE;
            (*br)++;
        }
        
    }
    else if(pret[v] == NILL)
    {
        //printf("Nema puta");
        glavnaPutanja[*q] = -10;
        (*q)++;
    }
    else
    {
        stampajPut(pret, s, pret[v], prosla, br, f, glavnaPutanja, q);
        prosla[v] = TRUE;
        (*br)++;
        //printf("%d ", v);
        glavnaPutanja[*q] = v;
        (*q)++;
    }
}

int imaPuta(int *put, int n)
{
    int i;
    for(i = 0; i < n; i++)
        if(put[i] == -10)
            return 0;
    return 1;
}

void izracunaj(int *put, double **graf, double **zaKilom, int q, double *ukupnaC, double *ukupnaK)
{
    int i;

    for(i = 0; i < q - 1; i++)
    {
        (*ukupnaC) += graf[put[i]][put[i + 1]];
        (*ukupnaK) += zaKilom[put[i]][put[i + 1]];
    }

}



void main()
{
    double **graf, **zaCenu, **zaKilom, *d;
    int *obidjeni, *pret1, *glavnaPutanja, *prosla;
    int i, j, n, m, tipPuta, u, v;
    double cenaGoriva, potrosnjaAutoput, potrosnjaRegularni, cenaAutoputa, kilometraza, w;
    int p, k;
    int brObidjenih = 0;
    int f = 0;
    int q = 0;

    double ukupnaC = 0;
    double ukupnaK = 0;

    scanf("%lf", &cenaGoriva);
    scanf("%lf%lf", &potrosnjaAutoput, &potrosnjaRegularni);
    scanf("%d%d", &n, &m);

    potrosnjaAutoput /= 100;
    potrosnjaRegularni /= 100;


    //printf("radi\n");

    graf = (double **)malloc(n * sizeof(double *));
    zaCenu = (double **)malloc(n * sizeof(double *));
    zaKilom = (double **)malloc(n * sizeof(double *));
    for(i = 0; i < n; i++)
    {
        graf[i] = (double *)malloc(n * sizeof(double));
        zaCenu[i] = (double *)malloc(n * sizeof(double));
        zaKilom[i] = (double *)malloc(n * sizeof(double));
    }
        

    d = (double *)malloc(n * sizeof(double));
    pret1 = (int *)malloc(n * sizeof(int));

    glavnaPutanja = (int *)malloc((n + n) * sizeof(int));

    obidjeni = (int *)malloc(n * sizeof(int));
    prosla = (int *)malloc(n * sizeof(int));

    //printf("radi\n");

    for(i = 0; i < n; i++)
    {
        pret1[i] = NILL;
        obidjeni[i] = FALSE;
        prosla[i] = FALSE;
        d[i] = INF;

        for(j = 0; j < n; j++)
            graf[i][j] = INF;
    }
    //printf("radi\n");
/*
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < n; j++)
            printf("%.2lf ", graf[i][j]);
        printf("\n");
    }
*/

    for(i = 0; i < m; i++)
    {
        scanf("%d%d", &u, &v);
        scanf("%lf", &kilometraza);
        scanf("%d", &tipPuta);

        if(tipPuta == 1)
        {
            scanf("%lf", &cenaAutoputa);
            w = kilometraza * potrosnjaAutoput * cenaGoriva + cenaAutoputa;
        }
        else
        {
            w = kilometraza * potrosnjaRegularni * cenaGoriva;
        }

        if(jeManji(w, graf[u][v]) && jeManji(w, graf[v][u]))
        {
            graf[u][v] = w;
            graf[v][u] = w;
            zaKilom[u][v] = kilometraza;
            zaKilom[v][u] = kilometraza;
        }

    }
/*
    printf("\nSa tezinom puta\n");
    for(i = 0; i < n; i++)
    {
        for(j = 0; j < n; j++)
            printf("%.2lf ", graf[i][j]);
        printf("\n");
    }
*/

    scanf("%d%d", &p, &k);

    d[p] = 0;

    dijkstra(graf, d, obidjeni, pret1, n, n, prosla);
/*
    for(i = 0; i < n; i++)
        printf("%.2lf ", d[i]);
    printf("\n");

    for(i = 0; i < n; i++)
        printf("%d ", pret[i]);
    printf("\n");

    for(i = 0; i < n; i++)
        printf("%d ", obidjeni[i]);
    printf("\n");
*/
    //printf("Putanja\n");
    stampajPut(pret1, p, k, prosla, &brObidjenih, f, glavnaPutanja, &q);
    //printf("\n");
/*
    printf("Prosla\n");
    for(i = 0; i < n; i++)
        printf("%d ", prosla[i]);
    printf("\n");

    printf("Prosla je kroz %d grada\n", brObidjenih);
*/
    prosla[p] = 0;
    prosla[k] = 0;

    brObidjenih -= 2;

  //  printf("radi\n");
    for(i = 0; i < n; i++)
    {
        pret1[i] = NILL;
        obidjeni[i] = FALSE;
        d[i] = INF;
    }
   // printf("radi\n");

    d[k] = 0;

    dijkstra(graf, d, obidjeni, pret1, n, n-brObidjenih, prosla);
    
    f = 1;

    //printf("Putanja\n");
    stampajPut(pret1, k, p, prosla, &brObidjenih, f, glavnaPutanja, &q);
    //printf("\n");
/*
    printf("Prosla\n");
    for(i = 0; i < n; i++)
        printf("%d ", prosla[i]);
    printf("\n");
   */

   

   if(imaPuta(glavnaPutanja, q))
   {
       izracunaj(glavnaPutanja, graf, zaKilom, q, &ukupnaC, &ukupnaK);

       printf("%.4lf\n", ukupnaC);
       printf("%.4lf\n", ukupnaK);
       for(i = 0; i < q; i++)
        {
            

            printf("%d ", glavnaPutanja[i]);
        }
        printf("\n");
   }
   else
   {
       printf("-1\n");
   }





}