#include <stdio.h>
#include <stdlib.h>
//	duzina puta, prosecna potrosnja, cena, kilometraza

#define INF -1
#define true 1
#define false 0

int jeManji(double a, double b)
{
	if(a==INF)
		return false;
	if(b==INF)
		return true;
		
	return a < b;
}

int nadjiMinimum(double *d, int *obidjen, int *posecen, int n)
{
	int i, minPozicija=INF;
	double min = INF;
	
	for(i=0;i<n;i++)
		if(jeManji(d[i],min))
		{
			min=d[i];
			minPozicija=i;
		}
		
	return minPozicija;
}

void dijkstra(double **graf,double *d,int *pret,int *obidjen,int *posecen,int n)
{
	int u,v,i;
	
	for(i=0;i<n;i++)
	{
		u=nadjiMinimum(d,obidjen,posecen,n);
		obidjen[u]=true;
		for(v=0;v<n;v++)
			if(graf[u][v]!=INF && obidjen[v]==false && posecen[v]==false)
				if(jeManji(d[u]+graf[u][v],d[v]))
				{
					d[v]=d[u]+graf[u][v];
					pret[v]=u;
				}
	}
}
void poseti(int polaziste,int odrediste, int *posecen, int *pret, int *d, int *kilometraza,int *suma)
{
	if(polaziste==odrediste){
		posecen[odrediste]=true;
	}
	else
	{
		poseti(polaziste,pret[odrediste],posecen,pret);
		posecen[odrediste]=true;
	}
}

int main()
{
	double cenaGoriva, potrosnjaAutoput, potrosnjaRegionalni, l, putarina;
	int n,m,u,v,autoput;
	int polaziste, odrediste;
	double **graf;
	double *d1, *d2;
	int *obidjen1, *obidjen2, *posecen, *pret1, *pret2;
	int i,j;
	
	scanf("%lf",&cenaGoriva);
	scanf("%lf%lf",&potrosnjaAutoput,&potrosnjaRegionalni);
	scanf("%d%d",&n,&m);
	
	graf=(double**)malloc(sizeof(double*)*(n));
	d1=(double*)malloc(sizeof(double)*n);
	d2=(double*)malloc(sizeof(double)*n);
	obidjen1=(int*)malloc(sizeof(int)*n);
	obidjen2=(int*)malloc(sizeof(int)*n);
	posecen=(int*)malloc(sizeof(int)*n);
	pret1=(int*)malloc(sizeof(int)*n);
	pret2=(int*)malloc(sizeof(int)*n);
	
	for(i=0;i<n;i++)
	{
		graf[i]=(double*)malloc(sizeof(double)*n);
		d1[i]=INF;
		d2[i]=INF;
		obidjen1[i]=false;
		obidjen2[i]=false;
		posecen[i]=false;
		pret1[i]=INF;
		pret2[i]=INF;
	}
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
			graf[i][j]=INF;
	
	double proporcija;
	double potrosnja;
	
	for(i=0;i<m;i++)
	{
		scanf("%d%d%lf%d",&u,&v,&l,&autoput);
		if(autoput==1){
			scanf("%lf",&putarina);
			potrosnja=potrosnjaAutoput;
		}
		else {
			putarina=0;
			potrosnja=potrosnjaRegionalni;
		}
		
		proporcija = ((potrosnja * cenaGoriva)*l)/100 +putarina;
		//printf("%d %d %lf\n",u,v,proporcija+putarina);
		
		if(jeManji(proporcija,graf[u][v]))
		{
			graf[u][v]=graf[v][u]=proporcija;
		}
		
	}
	
	scanf("%d%d",&polaziste,&odrediste);
	d1[polaziste]=0;
	d2[odrediste]=0;
	
	double kilometraza=0;
	double suma=0;
	
	dijkstra(graf,d1,pret1,obidjen1,posecen,n);
	poseti(polaziste,odrediste,posecen, pret1,d1,&kilometraza,&suma);
	dijkstra(graf,d2,pret2,obidjen2,posecen,n);
	poseti(polaziste,odrediste,posecen, pret2,d2,&kilometraza,&suma);
	
	
	
	
	for(i=0;i<n;i++)
		printf("%lf\n",d1[i]);
		
	
	
	//for(i=0;i<n;i++, putchar('\n'))
		//for(j=0;j<n;j++)
			//printf("%lf\t",graf[i][j]);
}	










