#include <stdio.h>
#include <stdlib.h>


#define INF -1
#define NILL -1
#define TRUE 1
#define FALSE 0


struct put
{
	int grad1,grad2;
	float kilometraza;
	int oznaka;
	float putarina;
	float cenaPuta;
};

int jeManji(int i,int j)
{
	if(i==INF)
	{
		return FALSE;
	}
	if(j==INF)
	{
		return TRUE;
	}

	return i<j;
}


int nadjiNajmanji(int *obidjen,int *d,int n)
{
	int i;
	int min=INF;
	int minCvor=NILL;
	for(i=0;i<n;i++)
	{
		if(obidjen[i]==FALSE && jeManji(d[i],min))
		{
			min=d[i];
			minCvor=i;
		}
	}
	return minCvor;
}


void relax(float **graf,int *d,int *pret,int u,int v)
{
	if(jeManji(d[u]+graf[u][v],d[v]))
	{
		d[v]=d[u]+graf[u][v];
		pret[v]=u;
	}
}


void dijkstra(float **graf,int *obidjen,int *d,int *pret,int n)
{
	int i,u,v;

	for(i=0;i<n;i++)
	{
		u=nadjiNajmanji(obidjen,d,n);
		obidjen[u]=TRUE;
		for(v=0;v<n;v++)
		{
			if(graf[u][v]!=INF && obidjen[v]==FALSE)
			{
				relax(graf,d,pret,u,v);
			}
		}
	}
}


int rekonstrukcija(int i,int polaziste,int *pret,int *dS,int *dA)
{
	int rbr;
	if(i==polaziste)
	{
		return -1;
	}
	else
	{
		rbr=rekonstrukcija(pret[i],polaziste,pret,dS,dA);
		if(rbr==-1 && dA[i]<=dS[i])
		{
			return i;
		}
		else return rbr;
	}
}


int main()
{
	int *obidjenS,*obidjenA,*obidjenK,*dS,*dA,*dK,*pretS,*pretK,*pretA;
	float **graf,**kilometraza;
	int i,j,n,m;
	int u,v;
	int rbr;
	struct put *putevi;
	int polaziste,odrediste;


	float cenaGoriva,potrosnjaGorivaAutoPut,potrosnjaGoriaRegionalniPut;

	scanf("%f%f%f" ,&cenaGoriva,&potrosnjaGorivaAutoPut,&potrosnjaGoriaRegionalniPut);
	scanf("%d%d" ,&n,&m);

	graf=(float**)malloc(sizeof(float*)*n);
	kilometraza=(float**)malloc(sizeof(float)*n);
	obidjenK=(int*)malloc(sizeof(int)*n);
	obidjenS=(int*)malloc(sizeof(int)*n);
	obidjenA=(int*)malloc(sizeof(int)*n);
	dK=(int*)malloc(sizeof(int)*n);
	dS=(int*)malloc(sizeof(int)*n);
	dA=(int*)malloc(sizeof(int)*n);
	pretS=(int*)malloc(sizeof(int)*n);
	pretK=(int*)malloc(sizeof(int)*n);
	pretA=(int*)malloc(sizeof(int)*n);
	for(i=0;i<n;i++)
	{
		graf[i]=(float*)malloc(sizeof(float)*n);
		kilometraza[i]=(float*)malloc(sizeof(float)*n);
		dS[i]=INF;
		dA[i]=INF;
		dK[i]=INF;
		obidjenA[i]=NILL;
		obidjenS[i]=NILL;
		obidjenK[i]=NILL;
		pretA[i]=FALSE;
		pretK[i]=FALSE;
		pretS[i]=FALSE;
	}

	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			graf[i][j]=INF;
			kilometraza[i][j]=INF;
		}
	}

	putevi=(struct put*)malloc(sizeof(struct put)*m);

	for(i=0;i<m;i++)
	{
		scanf("%d%d" ,&putevi[i].grad1,&putevi[i].grad2);
		scanf("%f" ,&putevi[i].kilometraza);
		scanf("%d" ,&putevi[i].oznaka);
		if(putevi[i].oznaka==1)
		{
			scanf("%f" ,&putevi[i].putarina);
		}
		else
		{
			putevi[i].putarina=-1;
		}


		if(putevi[i].oznaka==1)
			putevi[i].cenaPuta=putevi[i].putarina+putevi[i].kilometraza/100*potrosnjaGorivaAutoPut*cenaGoriva;
		else
		{
			putevi[i].cenaPuta=putevi[i].kilometraza/100*potrosnjaGoriaRegionalniPut*cenaGoriva;
		}
	}

	for(i=0;i<m;i++)
	{
		u=putevi[i].grad1;
		v=putevi[i].grad2;
		graf[u][v]=putevi[i].cenaPuta;
		graf[v][u]=putevi[i].cenaPuta;
		kilometraza[u][v]=putevi[i].kilometraza;
		kilometraza[v][u]=putevi[i].kilometraza;
	}

	scanf("%d%d" ,&polaziste,&odrediste);
	dA[polaziste]=0;
	dS[odrediste]=0;
	dK[polaziste]=0;
/*
	dijkstra(graf,obidjenS,dS,pretS,n);
	dijkstra(graf,obidjenA,dA,pretA,n);
	dijkstra(graf,obidjenS,dS,pretS,n);

	int brLokacije;
	float cenaPutovanja;
	float kilometrazaPutovanja;
	brLokacije=rekonstrukcija(polaziste,polaziste,pretS,dS,dA);
	if(brLokacije!=-1)
	{
		cenaPutovanja=dS[brLokacije];
	}
	else
	{
		cenaPutovanja=-1;
	}


*/
/*
	printf("%f\n" ,cenaPutovanja);*/
	/*printf("%f\n" ,kilometrazaPutovanja);*/



}