#include <stdio.h>
#include <stdlib.h>

#define NEDEFINISANO (-1)
#define TRUE 1
#define FALSE 0

float cenaGoriva,potrAuto,potrReg;
int n,m;

typedef struct{
	int u;
	int v;
	float w;
	float duzina;
	int autoput;
	float putarina;
	int povezani;
}Veza;

Veza **graf;
float *obidjen,*d;
int *uvrsteneVeze;
int *pret;
int pol,odr;
float cenaPutovanja=0.0;
int *obidjeniGradovi;

int jeManji(float u,float v)
{
	if(u==NEDEFINISANO)
		return FALSE;
	if(v==NEDEFINISANO)
		return TRUE;
	return u<v;
}

int najmanji()
{
	int i,cvorMin=-1;
	float min=NEDEFINISANO;
	
	for(i=0;i<n;i++)
	{
		if(obidjen[i]==FALSE && jeManji(d[i],min))
		{
			min=d[i];
			cvorMin=i;
		}
	}
	
	return cvorMin;
}

void relax(int u,int v,int smer)
{
	if(smer==1) //od polazista
	{
		if(d[u]+graf[u][v].duzina<d[v])
		{
			d[v]=d[u]+graf[u][v].duzina;
			pret[v]=u;
			obidjen[v]=TRUE;
			obidjeniGradovi[v]=TRUE;
		}
	}
	else //od odredista, pazim da ne naidjem na iste gradove
	{
		if(obidjeniGradovi[v]==FALSE) //ako nije prosla kroz taj grad uopste
		{
			if(d[u]+graf[u][v].duzina<d[v])
			{
				d[v]=d[u]+graf[u][v].duzina;
				pret[v]=u;
				obidjen[v]=TRUE;
				obidjeniGradovi[v]=TRUE;
			}
		}
	}
}

void dijkstra(int smer)
{
	int i,u,v;
	for(i=0;i<n;i++)
	{
		printf("OVDE\n");
		u=najmanji();
		printf("u %d\n",u);
		obidjen[u]=TRUE;
		for(v=0;v<n;v++)
		{
			if(graf[u][v].povezani!=NEDEFINISANO && obidjen[v]==FALSE)
			{
				relax(u,v,smer);
			}
		}
	}
}

void rekonstrukcija(int pol,int odr)
{
	if(pol==odr)
	{
		printf("%d	",pol);
	}
	else if(pret[pol]==NEDEFINISANO)
	{
		printf("%d\n",-1);
	}
	else
	{
		rekonstrukcija(pret[pol],odr);
		printf("%d	",pol);
	}
}

int main()
{
	scanf("%f",&cenaGoriva);
	scanf("%f%f",&potrAuto,&potrReg);
	scanf("%d%d",&n,&m);
	int u,v,i,j,a;
	float l,p;
	
	graf=(Veza**)malloc(n*sizeof(Veza*));
	pret=(int*)malloc(n*sizeof(int));
	d=(float*)malloc(n*sizeof(float));
	obidjen=(float*)malloc(n*sizeof(float));
	uvrsteneVeze=(int*)malloc(m*sizeof(int));
	obidjeniGradovi=(int*)malloc(n*sizeof(int));

	for(i=0;i<n;i++)
	{
		graf[i]=(Veza*)malloc(n*sizeof(Veza));
		pret[i]=NEDEFINISANO;
		d[i]=NEDEFINISANO;
		obidjen[i]=FALSE;
		obidjeniGradovi[i]=FALSE;
	}
	
	for(i=0;i<n;i++)
	{
		for(j=0;j<n;j++)
		{
			graf[i][j].povezani=NEDEFINISANO;
		}
	}
	
	for(i=0;i<m;i++)
	{
		scanf("%d%d%f%d",&u,&v,&l,&a);
		if(a==1) scanf("%f",&p);
		
		graf[u][v].u=u;
		graf[u][v].v=v;
		graf[v][u].u=v;
		graf[v][u].v=u;
		graf[u][v].povezani=graf[v][u].povezani=1;
		graf[u][v].duzina=graf[v][u].duzina=l;
		
		//pret[v]=u;
		//pret[u]=v;
		
		graf[u][v].autoput=a;
		if(a==1){
			 graf[u][v].putarina=graf[v][u].putarina=p;
			 graf[u][v].w=graf[v][u].w=(l/100)*potrAuto*cenaGoriva+p;
		 }
		else {
			graf[u][v].putarina=graf[v][u].putarina=NEDEFINISANO;
			graf[u][v].w=graf[v][u].w=(l/100)*potrReg*cenaGoriva;
		}
		
		
	}
	
	scanf("%d%d",&pol,&odr);
	d[pol]=0;
	dijkstra(1);
	
	d[odr]=0;
	dijkstra(-1);
	
	printf("%f\n",graf[pol][odr].w+graf[odr][pol].w);
	printf("%f\n",graf[pol][odr].duzina+graf[odr][pol].duzina);
	rekonstrukcija(pol,odr);
	rekonstrukcija(odr,pol);
}
